<?php
/**
 * $Id: cnf.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');
class JcsControllerCnf extends JController
{

	function __construct()
	{
		parent::__construct();
		$this->registerTask( 'apply', 'save' );
		JRequest::setVar( 'view', 'cnf' );
	}

	function display()
	{
		JRequest::setVar('view', 'cnf');
		parent::display();
	}

	function apply()
	{
		$this->save();
	}

	function save()
	{
		global $mainframe;

		$task 	= JRequest::getCmd( 'task' );

		foreach ($_POST['params'] as $var => $val) {
			if(is_array($val)) $_POST['params'][$var] = serialize($val);
		}

		$params = new JParameter( $_POST['params'], JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jcs'.DS.'params.xml' );
		$params->bind( $_POST['params'] );
		$ini = $params->toString();

		JFile::write( JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jcs'.DS.'config.ini', $ini );

		$msg = JText::_( 'Successfully Saved Configuration' );
		switch ( $task ) {
			case 'apply':
				$mainframe->redirect( 'index.php?option=com_jcs&controller=cnf', $msg );
				break;
			case 'save':
			default:
				$mainframe->redirect( 'index.php?option=com_jcs', $msg );
				break;
		}
	}

	function cancel()
	{
		global $mainframe;
		$link = 'index.php?option=com_jcs';
		$mainframe->redirect( $link );
	}

	function set( $key, $value, $group = '_default' )
	{
		global $JS_params_obj;

		if( ! isset($JS_params_obj) ){
			JError::raiseWarning( 500, JText::_('Config controller is not initialised.') );
			return false;
		}

		$JS_params_obj->set( $key, $value, $group );

		$ini = $JS_params_obj->toString();

		JFile::write( JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jcs'.DS.'config.ini', $ini );

		return true;
	}

	function initialyze()
	{
		$uri = & JFactory::getURI();
		$ini = "";
		if (JFile::exists(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jcs'.DS.'config.ini'))
		{
			$ini = JFile::read( JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jcs'.DS.'config.ini' );
		}
		else if($ini=='')
		{
			return;
		}
		$config_params = new JParameter( $ini, JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jcs'.DS.'params.xml' );

		$GLOBALS[ 'JS_params_obj' ] = $config_params ;

		$params_array = $config_params->toArray();
		//print'<table>';
		foreach($params_array AS $key => $val){
			$name = strtoupper('JCS_'.$key);
			//print '<tr><td>'.strtoupper($name).'</td><td>'.$val.'</td></tr>';
			if(defined(strtoupper($name))){
				continue;
			}

			define(strtoupper($name), $val, true);
		}
		//print'</table>';
	}
}
?>