<?php
/**
 * $Id: coupon.php 8492 2012-06-15 10:54:05Z alfiya $
 * $LastChangedDate: 2012-06-15 16:54:05 +0600 (Fri, 15 Jun 2012) $
 * $LastChangedBy: alfiya $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('dead');

jimport('joomla.application.component.model');

class JcsModelCoupon extends JModel
{
    var $_data = null;
	var $_total = null;
	var $_pagination = null;
	var $_id = null;
	
    function __construct()
    {
        parent::__construct();
        
        global $mainframe, $option;

		$limit      = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'coupon.limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
		
		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}
	
	
    function getData()
	{
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}
	function _buildQuery()
	{
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();

		$query = '
		SELECT * , ctime AS `start`, extime AS `finish`, IF(extime < NOW(),1,0) AS expire,  IF(used_num >= use_num,1,0) AS usedout
		FROM #__jcs_coupons '
		. $where
        . $orderby
         ;
          
          return $query;
	}
	function _buildContentOrderBy()
	{
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'users.filter_order',		'filter_order',		'value',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'users.filter_order_Dir',	'filter_order_Dir',	'DESC',				'word' );

		$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.'';

		return $orderby;
	}
	function _buildContentWhere()
	{
		global $mainframe, $option;

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'coupons.filter_state',		'filter_state',		'',				'word' );
		$filter_type		= $mainframe->getUserStateFromRequest( $option.'coupons.filter_type',		'filter_type',		'',			'string' );
        $search				= $mainframe->getUserStateFromRequest( $option.'coupons.search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );
        
		$where = array();

		if ($filter_type) {
			$where[] = "discount_type = '".$filter_type."'";
		}
		if ($search) {
			$w  = ' ( LOWER(value) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' OR LOWER(discount_type) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' )';
			$where[] = $w;
		}
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where[] = 'published = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'published = 0';
			}
		}


		//JUser conditions
		if( JRequest::getVar('no_html', 0 ) ){

			$ju_cid = JRequest::getVar('ju_cid', array() );

			if( is_array($ju_cid) && count($ju_cid) ){
				$where[] = ' id IN ('.implode( ' , ', $ju_cid ).') ';
			}

		}//JUser conditions (end)


		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}
	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}

	function setId($id)
	{
		$this->_id		= $id;
		$this->_data	= null;
		$this->_plan	= null;
	}
	
	function getPlan()
	{
		if ($this->_plan == null)
		{
			if($this->_id)
			{
				$query = 'SELECT * FROM #__jcs_coupons WHERE id = '.(int) $this->_id;
				$this->_db->setQuery($query);
				$this->_plan = $this->_db->loadObject();
				return $this->_plan;
			}
			else 
			{
				return $this->initData();
			}
		}
		return $this->initData();
	}
	function initData()
	{
		$plan = new stdClass();
		$plan->id = null;
		$plan->value = '';
		$plan->discount = 0;
		$plan->discount_type = 'procent';
		$plan->user_ids = '';
		$plan->strict = 0;
		$plan->ctime = strftime('%Y-%m-%d %H:%M:%S', time());
		$plan->extime = 'Never';
		$plan->use_user = 0;
		$plan->use_num = 0;
		$plan->used_num = 0;
		$plan->trash = 0;
		$plan->checked_out = 0;
		$plan->checked_out_time = null;
		$plan->published = 1;
		$plan->plan_ids = '';
		$this->_plan = $plan;
		return $plan;
	}
	function store($data)
	{
		$row =& $this->getTable();
		
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			//echo "1111"; exit;
			return false;
		}
		
		if (!$row->check()) {
			$this->setError('Check fail'. $row->_error);
			//echo "1111"; exit;
			return false;
		}
		
		if (!$row->store()) {
			$this->setError('Cannot Store'. $row->getError());
			return false;
		}
		$this->id = $row->id;
		
		return true;
	}
	function checkin()
	{
		if ($this->_id)
		{
			$coupon = & $this->getTable();
			if(! $coupon->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}
}
?>   