<?php
/**
 * $Id: jcs.php 8492 2012-06-15 10:54:05Z alfiya $
 * $LastChangedDate: 2012-06-15 16:54:05 +0600 (Fri, 15 Jun 2012) $
 * $LastChangedBy: alfiya $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();
jimport('joomla.application.component.model');
jimport('joomla.html.pane');

class JcsModelJcs extends JModel
{
	var $_data = null;
	var $_total = null;
	var $_pagination = null;
	var  $_id = null;

	function __construct()
	{
		parent::__construct();

		global $mainframe, $option;

		// Get the pagination request variables
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}
	function setId($id)
	{
		// Set weblink id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}
	function &getData2()
	{
		// Load the weblink data
		if ($this->_loadData())
		{
			// Initialize some variables
			$user = &JFactory::getUser();

			// Check to see if the category is published
		}
		else  $this->_initData();

		return $this->_data;
	}
	function getData()
	{
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}
	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}

	function _buildQuery()
	{
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();

		$query = ' SELECT a.*, cc.title AS cat, u.name AS editor, COUNT(us.id) AS numofsub '
		. ' FROM #__jcs_plans AS a '
		. ' LEFT JOIN #__categories AS cc ON cc.id = a.catid '
		. ' LEFT JOIN #__users AS u ON u.id = a.checked_out '
		. ' LEFT JOIN #__jcs_user_subscr AS us ON us.subscription_id = a.id '
		. $where
		. ' GROUP BY a.id'
		. $orderby
		;
		//echo $query;
		return $query;
	}

	function _buildContentOrderBy()
	{
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );

		if ($filter_order == 'a.ordering'){
			$orderby 	= ' ORDER BY cc.ordering ASC, a.ordering '.$filter_order_Dir;
		} else {
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , cat, a.ordering ';
		}

		return $orderby;
	}

	function _buildContentWhere()
	{
		global $mainframe, $option;

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'filter_state',		'filter_state',		'',				'word' );
		$filter_catid		= $mainframe->getUserStateFromRequest( $option.'filter_catid',		'filter_catid',		0,				'int' );
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

		$where = array();

		if ($filter_catid > 0) {
			$where[] = 'a.catid = '.(int) $filter_catid;
		}
		if ($search) {
			$where[] = 'LOWER(a.name) LIKE '.$this->_db->Quote('%'.$search.'%');
		}
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where[] = 'a.published = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'a.published = 0';
			}
		}

		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}

	function publish($cid = array(), $publish = 1)
	{
		$user 	=& JFactory::getUser();
		//echo "dfgdfgd"; exit;
		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$query = 'UPDATE #__jcs_plans'
			. ' SET published = '.(int) $publish
			. ' WHERE id IN ( '.$cids.' )'
			. ' AND ( checked_out = 0 OR ( checked_out = '.(int) $user->get('id').' ) )'
			;
			$this->_db->setQuery( $query );

			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

	function move($direction)
	{
		$row =& $this->getTable();
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->move( $direction, ' catid = '.(int) $row->catid.' AND published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}

	function saveorder($cid = array(), $order)
	{
		$row =& $this->getTable();
		$groupings = array();

		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );
			// track categories
			$groupings[] = $row->catid;

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group){
			$row->reorder('catid = '.(int) $group);
		}

		return true;
	}
	function checkout($uid = null)
	{
		if ($this->_id)
		{
			// Make sure we have a user id to checkout the article with
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			// Lets get to it and checkout the thing...
			$weblink = & $this->getTable();
			if(!$weblink->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}
	function isCheckedOut( $uid=0 )
	{
		if ($this->_loadData())
		{
			if ($uid) {
				return ($this->_data->checked_out && $this->_data->checked_out != $uid);
			} else {
				return $this->_data->checked_out;
			}
		}
	}
	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = 'SELECT p.*, cc.title AS cat,'.
			' cc.published AS cat_pub'.
			' FROM #__jcs_plans AS p' .
			' LEFT JOIN #__categories AS cc ON cc.id = p.catid' .
			' WHERE p.id = '.(int) $this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}
	function store($data)
	{
		$row =& $this->getTable();

		// Bind the form fields to the web link table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		$this->_db->setQuery("SELECT NOW()");
		$now = $this->_db->loadResult();
		//$row->created = $now;
		// Create the timestamp for the date
		if(!$data['ctime'])
		$row->ctime = $now;
		else
		$row->ctime = $data['ctime'];
		//echo $row->id; exit;
		// if new item, order last in appropriate group
		if (!$row->id) {
			$where = 'catid = ' . (int) $row->catid ;
			$row->ordering = $row->getNextOrder( $where );
		}

		// Make sure the web link table is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		$this->id = $row->id;
		return true;
	}
	function delete($cid = array())
	{
		$result = false;

		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'DELETE FROM #__jcs_plans'
			. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if(!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}
	function checkin()
	{
		if ($this->_id)
		{
			$weblink = & $this->getTable();
			if(! $weblink->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}
	function _categoryList($default)
	{
		$ctegs = explode(",", $default);
		if($ctegs){
			foreach($ctegs AS $ct)
			{
				$selected[]->id = $ct;
			}
		}
		//$db     =& JFactory::getDBO();
		$category = array();
		$query = "SELECT id, title FROM `#__sections`";
		$this->_db->setQuery( $query );
		$sect = $this->_db->loadObjectList();
		JHTML::_('select.option', '0', JText::_( 'Top' ), 'id', 'name' );
		foreach($sect AS $sec)
		{
			$query = "SELECT id, title FROM `#__categories` WHERE `section` = $sec->id";
			$this->_db->setQuery( $query );
			$catg = $this->_db->loadObjectList();
			if(count($catg) <= 0) continue;
			foreach($catg AS $cat)
			{
				//echo $sec->title.'/'.$cat->title.'<BR>';
				$category[] = JHTML::_('select.option', $cat->id, $sec->title.'/'.$cat->title, 'id', 'title' );
			}
		}
		return JHTML::_('select.genericlist', $category, 'category[]', 'class="inputbox" size="7"  multiple="true" ', 'id', 'title', $selected);
	}

	function _plansList($name, $default, $current_id = false)
	{
		if(is_array($default))
		$ctegs = $default;
		else
		$ctegs = explode(",", $default);
		if($ctegs){
			foreach($ctegs AS $ct)
			{
				$selected[]->id = $ct;
			}
		}
		$opt = array();
		$query = "SELECT id, title FROM `#__categories` WHERE `section`='com_jcs' AND published = '1'";
		$this->_db->setQuery( $query );
		$cats = $this->_db->loadObjectList();
		//JHTML::_('select.option', '0', JText::_( 'Top' ), 'id', 'name' );
		foreach($cats AS $k=>$cat)
		{
			$query = "SELECT id, name FROM `#__jcs_plans` WHERE `catid` = '".$cat->id."' AND published = '1'";
			if($current_id)
			$query .= " AND `id` != '".$current_id."'";
			$this->_db->setQuery( $query );
			$plans = $this->_db->loadObjectList();
			if(count($plans) <= 0) continue;

			$opt[] = JHTML::_('select.optgroup', $cat->title,  'id', 'title');
			foreach($plans AS $plan)
			{
				$opt[] = JHTML::_('select.option', $plan->id, $plan->name, 'id', 'title' );
			}
		}
		$list = JHTML::_('select.genericlist', $opt, $name.'[]', 'class="inputbox" size="'.((count($opt) < 10) ? count($opt)+1 : 10).'" multiple="true"', 'id', 'title', $selected);
		return $list;
	}
	/*
	 function _plansList($default, $current_id = false)
	 {
	 $ctegs = explode(",", $default);
	 if($ctegs){
	 foreach($ctegs AS $ct)
	 {
	 $selected[]->id = $ct;
	 }
	 }
	 $opt = array();
	 $query = "SELECT id, title FROM `#__categories` WHERE `section`='com_jcs' AND published = '1'";
	 $this->_db->setQuery( $query );
	 $cats = $this->_db->loadObjectList();
	 //JHTML::_('select.option', '0', JText::_( 'Top' ), 'id', 'name' );
	 foreach($cats AS $k=>$cat)
	 {
	 $query = "SELECT id, name FROM `#__jcs_plans` WHERE `catid` = '".$cat->id."' AND published = '1'";
	 if($current_id)
	 $query .= " AND `id` != '".$current_id."'";
	 $this->_db->setQuery( $query );
	 $plans = $this->_db->loadObjectList();
	 if(count($plans) <= 0) continue;

	 $opt[] = JHTML::_('select.optgroup', $cat->title,  'id', 'title');
	 foreach($plans AS $plan)
	 {
	 $opt[] = JHTML::_('select.option', $plan->id, $plan->name, 'id', 'title' );
	 }
	 }
	 $list = JHTML::_('select.genericlist', $opt, 'req_plans[]', 'class="inputbox" size="'.((count($opt) < 10) ? count($opt)+1 : 10).'" multiple="true"', 'id', 'title', $selected);
	 return $list;
	 }

	 function _plansGrantList($default = array(), $current_id = false)
	 {
	 $ctegs =(array) $default;
	 if($ctegs){
	 foreach($ctegs AS $ct)
	 {
	 $selected[]->id = $ct;
	 }
	 }
	 $opt = array();
	 $query = "SELECT id, title FROM `#__categories` WHERE `section`='com_jcs' AND published = '1'";
	 $this->_db->setQuery( $query );
	 $cats = $this->_db->loadObjectList();
	 foreach($cats AS $k=>$cat)
	 {
	 $query = "SELECT id, name FROM `#__jcs_plans` WHERE `catid` = '".$cat->id."' AND published = '1'";
	 if($current_id)
	 $query .= " AND `id` != '".$current_id."'";
	 $this->_db->setQuery( $query );
	 $plans = $this->_db->loadObjectList();
	 if(count($plans) <= 0) continue;

	 $opt[] = JHTML::_('select.optgroup', $cat->title,  'id', 'title');
	 foreach($plans AS $plan)
	 {
	 $opt[] = JHTML::_('select.option', $plan->id, $plan->name, 'id', 'title' );
	 }
	 }
	 $list = JHTML::_('select.genericlist', $opt, 'grant_plans[]', 'class="inputbox" size="'.((count($opt) < 10) ? count($opt)+1 : 10).'" multiple="true"', 'id', 'title', $selected);
	 return $list;
	 }
	 */

	/*function _plansCrossPeriod($default, $current_id = false)
	 {
	 $opt = array();

	 $query = "SELECT id, name FROM `#__jcs_plans` WHERE published = '1'";
	 if($current_id)
	 $query .= " AND `id` != '".$current_id."'";
	 $this->_db->setQuery( $query );
	 $list = '';
	 if($plans = $this->_db->loadObjectList())
	 {
	 //$opt[] = JHTML::_('select.option', '', '- '.JText::_('Select plan from list').' -', 'id', 'title' );
	 foreach($plans AS $plan)
	 {
	 $opt[] = JHTML::_('select.option', $plan->id, $plan->name, 'id', 'title' );
	 }

	 $list = JHTML::_('select.genericlist', $opt, 'cp_plan', 'class="inputbox" size="'.((count($opt) < 10) ? count($opt)+1 : 10).'" ', 'id', 'title', $default);
	 }
	 return $list;
	 }*/

	function _plaginPayList($payparams)
	{
		$query = "SELECT * FROM #__plugins WHERE folder LIKE 'payment'";
		if(JCS_USED_BILL) $query .= " AND element='paybill'";
		$this->_db->setQuery( $query );
		$plagins = $this->_db->loadObjectList();

		$pane	=& JPane::getInstance('sliders');
		$out =  $pane->startPane("content-pane");


		foreach ($plagins as $plagin) {
			$out .= $pane->startPanel( $plagin->name, 'cpanel-panel-'.$plagin->name );

			if($payparams)
			{
				$params  = new JParameter($payparams, JApplicationHelper::getPath( 'plg_xml', $plagin->folder.DS.$plagin->element ), 'plugin' );
			}
			else
			{
				$params = new JParameter($plagin->params, JApplicationHelper::getPath( 'plg_xml', $plagin->folder.DS.$plagin->element ), 'plugin' );
			}

			$out .= $params->render('params');

			$out .= $pane->endPanel();
		}

		$out .= $pane->endPane();
		return $out;

	}


	function _plaginBillPayList($payparams)
	{
		$query = "SELECT * FROM #__plugins WHERE folder LIKE 'bill_gateways'";
		$this->_db->setQuery( $query );
		$plagins = $this->_db->loadObjectList();

		$pane	=& JPane::getInstance('sliders');
		$out =  $pane->startPane("content-pane");


		foreach ($plagins as $plagin) {
			$out .= $pane->startPanel( JText::_('Bill').' '.$plagin->name, 'cpanel-panel-'.$plagin->name );

			if($payparams)
			{
				$params  = new JParameter($payparams, JApplicationHelper::getPath( 'plg_xml', $plagin->folder.DS.$plagin->element ), 'plugin' );
			}
			else
			{
				$params = new JParameter($plagin->params, JApplicationHelper::getPath( 'plg_xml', $plagin->folder.DS.$plagin->element ), 'plugin' );
			}

			$out .= $params->render('params');

			$out .= $pane->endPanel();
		}

		$out .= $pane->endPane();
		return $out;

	}

	function _componentList($default, $params)
	{
		$comps = explode(",", $default);

		$query = "SELECT `option`, name FROM `#__components` WHERE parent = 0";
		$this->_db->setQuery( $query );
		$comp = $this->_db->loadObjectList();
		if(!$params) $params = array();
		$comp[count($comp) + 1]->option="com_wrapper";
		$comp[count($comp)]->name="Wrapper";
		$out = '<table width="100%" nowrap><tr>';
		$_i = 1;

		@$params = new JParameter($params);
		foreach($comp AS $com)
		{
			unset($param1,$param2);
			if(in_array($com->option, $comps))
			{
				$vis = 'visible';
				$dis = "block";
				$checked = ' checked="checked"';
			}
			else
			{
				$vis = 'hidden';
				$dis = "none";
				$checked = '';
			}
			if($_i == 1)
			{
				$out .= '</tr><tr>';
				$_i = 0;
			}else {
				$_i = 1;
			}
			$out .= '<td width="50%" valign="top" nowrap>';
			$out .= "<INPUT type=\"checkbox\" $checked id=\"check_$com->option\" onclick=\"jcsShowComParams('$com->option', '$com->option[]')\" name=\"component[]\" value=\"$com->option\" /> $com->name";
			$out .= "<DIV id=\"params_{$com->option}\" style=\"visibility:$vis;display:$dis;margin-left:20px;border:0px solid Silver; padding:0px\">";
			if($dis == 'block')
			{
				$out .= '<div style="border:1px solid Silver; padding:10px">';
				$out .= '<table class="admintable" cellpadding="0" cellspacing="0" ><tr>
	        			<td nowrap class="key" width="100" align="right">'.JText::_('URL Variable 1').":</td>
	        			<td><INPUT value=\"".$params->get($com->option.'_task1')."\" type=\"text\" name=\"task_$com->option[]\" class=\"inputbox\" /></td></tr>";

				@$out .= '<tr><td  nowrap class="key" width="100" align="right">'.JText::_('Variable Value 1').":</td>
	        			<td><INPUT value=\"".$params->get($com->option.'_val1')."\" type=\"text\" name=\"value_$com->option[]\" class=\"inputbox\" /></td></tr>";

				$out .= '</table><b>AND</b><table class="admintable" cellpadding="0" cellspacing="0" ><tr><td  nowrap class="key" width="100" align="right">'.JText::_('URL Variable 2').":</td>
	        			<td><INPUT value=\"".$params->get($com->option.'_task2')."\" type=\"text\" name=\"task_$com->option[]\" class=\"inputbox\" /></td></tr> ";

				@$out .= '<tr><td nowrap class="key" width="100" align="right">'.JText::_('Variable Value 2').":</td>
	        			<td><INPUT value=\"".$params->get($com->option.'_val2')."\" type=\"text\" name=\"value_$com->option[]\" class=\"inputbox\" /></td></tr></table>";
				//$out .= '</td></tr></table>';


				if(defined('JCS_MODE') && JCS_MODE)
				{
					$advcond = array('=', '!=', '>', '<', '>=', '<=', 'like \'(str)%\'', 'like \'%(str)\'', 'like \'%(str)%\'',
						'not like \'(str)%\'', 'not like \'%(str)\'', 'not like \'%(str)%\'');
					$opt = array();
					foreach($advcond as $val)
					{
						$opt[] = JHTML::_('select.option', $val, $val, 'id', 'title' );
					}
					$adv1 = JHTML::_('select.genericlist', $opt, "advcond_$com->option[]", 'class="inputbox"', 'id', 'title', $params->get($com->option.'_advcond1') );
					$out .= '<b>AND</b>
					<table class="admintable" cellpadding="0" cellspacing="0" >
						<tr>
							<td nowrap class="key" width="100" align="right">'.JText::_('URL Variable adv').':</td>
	        				<td><INPUT value="'.$params->get($com->option.'_advtask1').'" type="text" name="advtask_'.$com->option.'[]" class="inputbox" /></td>
	        			</tr>
						<tr>
							<td nowrap class="key" width="100" align="right">'.JText::_('Condition adv').':</td>
	        				<td>'.$adv1.'</td>
	        			</tr>
						<tr>
							<td nowrap class="key" width="100" align="right">
							<span class="hasTip" title="'.JText::_('Variable Value adv')."::". JText::_('If you use several values You need to select Condition Adv with value = or !=').'">
							'.JText::_('Variable Value adv').':</span></td>
	        				<td><INPUT value="'.$params->get($com->option.'_advval1').'" type="text" name="advvalue_'.$com->option.'[]" class="inputbox" /></td>
	        			</tr>
					</table>';
				}


				$out .= '</div>';
				$out .= '<b>OR</b>';
				$out .= '<div style="border:1px solid Silver; padding:10px">';

				$out .= '<table class="admintable" cellpadding="0" cellspacing="0" ><tr>
	        			<td nowrap class="key" width="100" align="right">'.JText::_('URL Variable 1').":</td>
	        			<td><INPUT value=\"".$params->get($com->option.'_task3')."\" type=\"text\" name=\"task_$com->option[]\" class=\"inputbox\" /></td></tr>";

				@$out .= '<tr><td  nowrap class="key" width="100" align="right">'.JText::_('Variable Value 1').":</td>
	        			<td><INPUT value=\"".$params->get($com->option.'_val3')."\" type=\"text\" name=\"value_$com->option[]\" class=\"inputbox\" /></td></tr>";

				$out .= '</table><b>AND</b><table class="admintable" cellpadding="0" cellspacing="0" ><tr><td  nowrap class="key" width="100" align="right">'.JText::_('URL Variable 2').":</td>
	        			<td><INPUT value=\"".$params->get($com->option.'_task4')."\" type=\"text\" name=\"task_$com->option[]\" class=\"inputbox\" /></td></tr> ";

				@$out .= '<tr><td nowrap class="key" width="100" align="right">'.JText::_('Variable Value 2').":</td>
	        			<td><INPUT value=\"".$params->get($com->option.'_val4')."\" type=\"text\" name=\"value_$com->option[]\" class=\"inputbox\" /></td></tr></table>";

				if(defined('JCS_MODE') && JCS_MODE)
				{
					$adv2 = JHTML::_('select.genericlist', $opt, "advcond_$com->option[]", 'class="inputbox"', 'id', 'title', $params->get($com->option.'_advcond2') );

					$out .= '<b>AND</b>
					<table class="admintable" cellpadding="0" cellspacing="0" >
						<tr>
							<td nowrap class="key" width="100" align="right">'.JText::_('URL Variable adv').':</td>
	        				<td><INPUT value="'.$params->get($com->option.'_advtask2').'" type="text" name="advtask_'.$com->option.'[]" class="inputbox" /></td>
	        			</tr>
						<tr>
							<td nowrap class="key" width="100" align="right">'.JText::_('Condition adv').':</td>
	        				<td>'.$adv2.'</td>
	        			</tr>
						<tr>
							<td nowrap class="key" width="100" align="right">
							<span class="hasTip" title="'.JText::_('Variable Value adv')."::". JText::_('If you use several values You need to select Condition Adv with value = or !=').'">
							'.JText::_('Variable Value adv').':</span></td>
	        				<td><INPUT value="'.$params->get($com->option.'_advval2').'" type="text" name="advvalue_'.$com->option.'[]" class="inputbox" /></td>
	        			</tr>
					</table>';
				}

				$out .= '</td>';
				$out .= '</div>';
			}
			$out .= '</div>';

		}
		$out .= '</tr></table>';

		return $out;
	}
	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$weblink = new stdClass();
			$weblink->id          = NULL;
			$weblink->name        = '';
			$weblink->days        = 0;
			$weblink->days_type   = '';
			$weblink->price       = 0.00;
			$weblink->description = '';
			$weblink->published   = 1;
			$weblink->category    = '';
			$weblink->params      = '';
			$weblink->grant_reg   = 0;
			$weblink->grant_new   = 0;
			$weblink->granturl    = 0;
			$weblink->time_limit  = 0;
			$weblink->one_time    = 0;
			$weblink->alert_admin = 0;
			$weblink->component   = '';
			$weblink->adwords     = '';
			$weblink->ctime       = NULL;
			$weblink->discount    = 0.00;
			$weblink->invisible   = 0;
			$weblink->ordering    = 0;
			$weblink->catid       = 0;
			$weblink->finish_msg  = '';
			$weblink->gid         = 28;
			$weblink->usertype    = 'Registered';
			$weblink->data_fixed  = 0;
			$weblink->type_user   = 0;
			$weblink->type_article = 0;
			$weblink->type_category = 0;
			$weblink->type_component = 0;
			$weblink->checked_out = 0;
			$weblink->checked_out_time = 0;
			$weblink->cross_plans = '';
			$weblink->alerts = '';
			$this->_data					= $weblink;
			return (boolean) $this->_data;
		}
		return true;
	}
	function _groupList($gid)
	{
		$acl  =& JFactory::getACL();
		$user =& JFactory::getUser();

		//if(!$gid)

		$my_group = strtolower( $acl->get_group_name( $gid, 'ARO' ) );
		if ( $my_group == 'super administrator' && $user->get('gid') != 25 ) {
			$lists['gid'] = '<input type="hidden" name="gid" value="'. $user->get('gid') .'" /><strong>Super Administrator</strong>';
		} else if ( $user->get('gid') == 24 && $gid == 24 ) {
			$lists['gid'] = '<input type="hidden" name="gid" value="'. $user->get('gid') .'" /><strong>Administrator</strong>';
		} else {
			// ensure user can't add group higher than themselves
			$my_groups = $acl->get_object_groups( 'users', $user->get('id'), 'ARO' );
			if (is_array( $my_groups ) && count( $my_groups ) > 0) {
				$ex_groups = $acl->get_group_children( $my_groups[0], 'ARO', 'RECURSE' );
			} else {
				$ex_groups = array();
			}

			$gtree = $acl->get_group_children_tree( null, 'USERS', false );

			// remove users 'above' me
			$i = 0;
			while ($i < count( $gtree )) {
				if (in_array( $gtree[$i]->value, $ex_groups )) {
					array_splice( $gtree, $i, 1 );
				} else {
					$i++;
				}
			}

			$lists['gid'] 		= JHTML::_('select.genericlist', $gtree, 'gid', 'size="10"', 'value', 'text', $gid );
		}
		return $lists['gid'];
	}
	function _pagesList($granturl)
	{
		$query = "SELECT id, title, title_alias FROM `#__content` WHERE sectionid = '' AND catid = ''";
		$this->_db->setQuery( $query );
		$static = $this->_db->loadObjectList();
		$stscontent[] = JHTML::_('select.option', '', 'None', 'id', 'title' );
		foreach($static AS $stat)
		{
			$stscontent[] = JHTML::_('select.option', $stat->id, $stat->title, 'id', 'title' );
		}
		return JHTML::_('select.genericlist', $stscontent, 'granturl', 'class="inputbox"', 'id', 'title', $granturl);

	}

	function MuaInboxTypeList($default)
	{
		$opt = array();
		$query = "SELECT id, name FROM `#__js_inbox_types` WHERE published = '1'";
		$this->_db->setQuery( $query );
		$types = $this->_db->loadObjectList();
		settype($types, 'array');
		foreach($types AS $type)
		{
			$opt[] = JHTML::_('select.option', $type->id, $type->name, 'id', 'name' );
		}
		$list = JHTML::_('select.genericlist', $opt, 'mua_msg_type', 'class="inputbox" ', 'id', 'name', $default);
		return $list;

	}

	function getSubscribersByType($id, $type)
	{
		$sql = "SELECT COUNT(id) FROM #__jcs_user_subscr WHERE subscription_id = '$id' AND ";
		switch ($type)
		{
			case 'published':
				$sql .= "published = '1' AND ctime < NOW() AND extime > NOW()";
				break;
			case 'unpublished':
				$sql .= "published = '0'";
				break;
			case 'expired':
				$sql .= "extime < NOW()";
				break;
		}
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function _AutoChildPlans($auto_child, $current_id)
	{
		$selected = explode(',', $auto_child);
		$opt = array();
		$query = "SELECT id, title FROM `#__categories` WHERE `section`='com_jcs' AND published = '1'";
		$this->_db->setQuery( $query );
		$cats = $this->_db->loadObjectList();
		//JHTML::_('select.option', '0', JText::_( 'Top' ), 'id', 'name' );
		foreach($cats AS $k=>$cat)
		{
			$query = "SELECT id, name FROM `#__jcs_plans` WHERE `catid` = '".$cat->id."' AND published = '1'";
			if($current_id)
			$query .= " AND `id` != '".$current_id."'";
			$this->_db->setQuery( $query );
			$plans = $this->_db->loadObjectList();
			if(count($plans) <= 0) continue;

			$opt[] = JHTML::_('select.optgroup', $cat->title,  'id', 'title');
			foreach($plans AS $plan)
			{
				$opt[] = JHTML::_('select.option', $plan->id, $plan->name, 'id', 'title' );
			}
		}
		$size = (count($opt) < 10) ? count($opt) + 1 : 10;
		$out = '<table>
		<tr valign="middle">
			<td>'.JText::_('Select plans').':</td>
			<td></td>
			<td>
				<span class="hasTip" title="'.JText::_('Plans to be assigned to user').'::'.JText::_('These selected plans will be assigned to user as subscription plan in order they have been added to the list according to period you set in <b>Activate in</b>.').'">
					'.JText::_('Plans to be assigned to user').'
				</span>:</td>
		</tr>
		<tr valign="middle">';
		$list = JHTML::_('select.genericlist', $opt, 'sel_childs[]', 'class="inputbox" size="'.$size.'" multiple="true"', 'id', 'title', $selected);
		$out .= '<td>'.$list.'</td>';
		$out .= '
			<td>
				<input type="button" class="button" value=">>" onclick="addChildPlan(this.form.sel_childs);">
				<br><br>
				<input type="button" class="button" value="<<" onclick="removeChildPlan(this.form.childs)">
			</td>
			';
		$opt = array();
		if(count($selected))
		{
			foreach ($selected as $id)
			{
				$query = "SELECT id, name FROM `#__jcs_plans` WHERE `id` = '$id' ";
				$this->_db->setQuery( $query );
				if($plan = $this->_db->loadObject())
				{
					$opt[] = JHTML::_('select.option', $plan->id, $plan->name, 'id', 'title' );
				}
			}
		}
		$list2 = JHTML::_('select.genericlist', $opt, 'childs[]', 'class="inputbox" size="'.$size.'" style="width: 100px;" multiple="true"', 'id', 'title', $selected);
		$out .= '<td>'.$list2.'</td>';
		$out .= '</tr>
		</table>';
		$out .= '
		<script type="text/javascript">
		
			var d = document;
			function addChildPlan(vals)
			{
				for (i = 0; i < vals.length; i++)
				{
					//alert(vals[i].value + " " + vals[i].selected + " " + vals[i].text)
				    if(vals[i].selected)
				    {
						var option = document.createElement( "option" );
						option.value = vals[i].value;
						option.selected = true;
						var option_text = document.createTextNode( vals[i].text );
						option.appendChild( option_text ); 
						d.getElementById("childs").appendChild( option );
					}
				}
			}
			function removeChildPlan(vals)
			{
				for (i = vals.length - 1; i >= 0; i--)
				{
					if(vals[i].selected)
				    {
				   		vals[i] = null;
					}
				}				
			}
		</script>
		';
		return $out;
	}

}
?>
