<?php
/**
 * $Id: users.php 7421 2011-11-02 04:34:25Z alfiya $
 * $LastChangedDate: 2011-11-02 10:34:25 +0600 (Wed, 02 Nov 2011) $
 * $LastChangedBy: alfiya $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');

class JcsModelUsers extends JModel
{
	var $_data = null;
	var $_total = null;
	var $_pagination = null;
	var $_id = null;

	function __construct()
	{
		parent::__construct();

		global $mainframe, $option;

		// Get the pagination request variables
		$limit      = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'users.limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}

	function setId($id)
	{
		$this->_id		= $id;
		$this->_data	= null;
	}


	function getData()
	{
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}
	function _buildQuery()
	{
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();

		$query = '
		SELECT up.id, up.gateway, up.gateway_id, up.access_limit,
		       up.published, up.access_count,  up.price, up.checked_out,
		       u.name AS uname, u.email, u.id AS uid,
		       up.created, up.ctime, up.extime, 
           		p.name, p.params, 
          (TO_DAYS(up.extime) - TO_DAYS(NOW())) as days, p.id AS pid, 
          (TO_DAYS(up.extime) - TO_DAYS(up.ctime)) as days_enable  '
          . ' FROM #__jcs_user_subscr AS up '
          . ' LEFT JOIN #__users AS u ON u.id = up.user_id '
          . ' LEFT JOIN #__jcs_plans AS p ON up.subscription_id = p.id '
          . $where
          . $orderby
          ;
          /*
           * 		       DATE_FORMAT(up.created, \'%d, %b %Y\') AS created,
           DATE_FORMAT(up.ctime, \'%d, %b %Y\') AS ctime,
           DATE_FORMAT(up.extime,\'%d, %b %Y\' ) AS extime,
           */
          //echo $query;exit;
          return $query;
	}
	function _buildContentOrderBy()
	{
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'users.filter_order',		'filter_order',		'up.created',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'users.filter_order_Dir',	'filter_order_Dir',	'DESC',				'word' );

		$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.'';

		return $orderby;
	}
	function _buildContentWhere()
	{
		global $mainframe, $option;

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'users.filter_state',		'filter_state',		'',				'word' );
		$filter_plans		= $mainframe->getUserStateFromRequest( $option.'users.filter_plans',		'subscription_id',		0,	'int' );
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'users.filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'users.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'users.search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

		$where = array();

		if ($filter_plans > 0) {
			$where[] = 'p.id = '.(int) $filter_plans;
		}
		if ($search) {
			$w  = ' (LOWER(p.name) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' OR LOWER(u.name) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' OR LOWER(u.email) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' OR LOWER(u.id) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' OR LOWER(u.username) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' OR LOWER(up.gateway) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' OR LOWER(up.gateway_id) LIKE '.$this->_db->Quote('%'.$search.'%');
			$w .= ' )';
			$where[] = $w;
		}
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where[] = 'up.published = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'up.published = 0';
			}
		}


		//JUser conditions
		if( JRequest::getVar('no_html', 0 ) ){

			$ju_cid = JRequest::getVar('ju_cid', array() );

			if( is_array($ju_cid) && count($ju_cid) ){
				$where[] = ' u.id IN ('.implode( ' , ', $ju_cid ).') ';
			}

		}//JUser conditions (end)


		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}
	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}
	function getPlans($default)
	{
		$query = "SELECT id, name, price, days, days_type FROM `#__jcs_plans`";
		$this->_db->setQuery( $query );
		$static = $this->_db->loadObjectList();
		$stscontent[] = JHTML::_('select.option', '', '- Select Subscription Plan -', 'id', 'name' );
		foreach($static AS $stat)
		{
			$stscontent[] = JHTML::_('select.option', $stat->id,
			"(".str_replace(array("00", "Sign"), array($stat->price, JCS_GENERAL_CURR), JCS_LAYOUT_PRICE).") [$stat->days-$stat->days_type] $stat->name", 'id', 'name' );
		}
		return JHTML::_('select.genericlist', $stscontent, 'subscription_id', 'onchange=submitform();" class="inputbox"', 'id', 'name', $default);

	}
	function getPlans2($default)
	{
		$query = "SELECT id, name, price, days, days_type FROM `#__jcs_plans` WHERE published = '1'";
		$this->_db->setQuery( $query );
		$static = $this->_db->loadObjectList();
		$stscontent[] = JHTML::_('select.option', '', '- Select Subscription Plan -', 'id', 'name' );
		foreach($static AS $stat)
		{
			$stscontent[] = JHTML::_('select.option', $stat->id,
			"(".str_replace(array("00", "Sign"), array($stat->price, JCS_GENERAL_CURR), JCS_LAYOUT_PRICE).") [$stat->days-$stat->days_type] $stat->name", 'id', 'name' );
		}
		return JHTML::_('select.genericlist', $stscontent, 'subscription_id', 'class="inputbox"', 'id', 'name', $default);

	}
	function getUsers($default)
	{
		$query = "SELECT id, name, username FROM `#__users` where `block` = 0";
		$this->_db->setQuery( $query );
		$static = $this->_db->loadObjectList();
		$stscontent[] = JHTML::_('select.option', '', '- Select User -', 'id', 'name' );
		foreach($static AS $stat)
		{
			$stscontent[] = JHTML::_('select.option', $stat->id, "(ID: $stat->id)  $stat->name [$stat->username]", 'id', 'name' );
		}
		return JHTML::_('select.genericlist', $stscontent, 'user_id', ' class="inputbox"', 'id', 'name', $default);

	}

	function getFindUsers($search, $default)
	{
		$query = "SELECT id, name, username FROM `#__users` where `block` = 0 and username LIKE '$search%'";
		$this->_db->setQuery( $query );
		$static = $this->_db->loadObjectList();
		$stscontent[] = JHTML::_('select.option', '', '- Select User -', 'id', 'name' );
		foreach($static AS $stat)
		{
			$stscontent[] = JHTML::_('select.option', $stat->id, "(ID: $stat->id)  $stat->name [$stat->username]", 'id', 'name' );
		}
		return JHTML::_('select.genericlist', $stscontent, 'user_id', ' class="inputbox"', 'id', 'name', $default);

	}

	function publish($cid = array(), $publish = 1)
	{
		$user 	=& JFactory::getUser();
		//echo "dfgdfgd"; exit;
		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$query = 'UPDATE #__jcs_user_subscr'
			. ' SET published = '.(int) $publish
			. ' WHERE id IN ( '.$cids.' )'
			. ' AND ( checked_out = 0 OR ( checked_out = '.(int) $user->get('id').' ) )'
			;
			//	echo $query; exit();
			
			
			$sql = "SELECT u.name, u.email, p.name AS subscr, s.gateway_id, p.params, p.id, p.days, p.days_type, UNIX_TIMESTAMP(s.ctime) as ctime
			FROM #__jcs_user_subscr s
			JOIN #__users u ON s.user_id=u.id
			JOIN #__jcs_plans p ON s.subscription_id=p.id
			WHERE s.id IN ($cids)";
			$this->_db->setQuery( $sql );
			$data = $this->_db->loadObjectList();
			foreach($data as $val)
			{
				$params = new JParameter( $val->params );
				$plans = $params->get( 'plans_grant' );
				if($plans != '')
				{
					settype($plans, 'array');
					$sql = "UPDATE #__jcs_user_subscr
						 SET published = '".(int) $publish."'
						 WHERE subscription_id IN ( ".implode(",", $plans)." )
					AND gateway = '.granted' AND gateway_id = '$val->gateway_id'
					AND ( checked_out = 0 OR ( checked_out = ".(int) $user->get('id')." ) )";
					$this->_db->setQuery( $sql );
					if($this->_db->query())
					{
						$sql = "SELECT u.name, u.email, p.name AS subscr, s.gateway_id
						FROM #__jcs_user_subscr s
						JOIN #__users u ON s.user_id=u.id 
						JOIN #__jcs_plans p ON s.subscription_id=p.id 
						WHERE s.subscription_id IN ( ".implode(",", $plans)." )
						AND gateway = '.granted' AND gateway_id = '$val->gateway_id'";
						$this->_db->setQuery( $sql );
						$data2 = $this->_db->loadObjectList();
						if($data2) $data = array_merge($data , $data2);
					}
				}
				
				// AngelDesk Integration
				$ids = preg_replace("#[^0-9,]#iU", '', $params->get('ad_ids'));
				if(JCS_AD_ENABLE && JCS_AD_SECRET_WORD && $ids)
				{
					$soap = new SoapClient('https://angeldeskws.com/v1/public/api/adws.wsdl');
					$ids = explode(',', $ids);
					
					$p = $params->get('ad_period');
					if($p)
					{
						$period = $val->ctime + ($p * 86400);
						
						if(substr($p, 0, 5) == 'date:')
						{
							$period = strtotime(preg_replace("#[^0-9\-\:\ ]#iU", '', str_replace('date:', '', $p)));
						}
						
					}
					else 
					{
						switch($val->days_type)
						{
							case 'hours':
								$x = 3600;
								break;
							case 'days':
								$x = 1 * 86400;
								break;
							case 'weeks':
								$x = 7 * 86400;
								break;
							case 'months':
								$x = 30 * 86400;
								break;
							case 'years':
								$x = 365 * 86400;
								break;
						}
						$period = $val->ctime + ($val->days * $x); 
					}
					
					foreach ($ids AS $id)
					{
						$key = md5($val->email.$id.$publish.$period.JCS_AD_SECRET_WORD);
						$result = json_decode(@$soap->paidAccessCallback($val->email, $id, $publish, $period, $key));
						
						if($result == 'Ok!')
						{
							JError::raiseNotice(100, 'AngelDesk query successfull');
						}
						else 
						{
							JError::raiseWarning(100, 'AngelDesk query error: '. $result);
						}
						
					}
				}
				// end AngelDesk integration
			}

			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			if(!defined('JCS_GENERAL_ACTIVATE_ALERT') || JCS_GENERAL_ACTIVATE_ALERT )
			{
				//send notifications to users
				$this->sendEmail($data, $publish);
			}
		}

		return true;
	}
	function checkout($uid = null)
	{
		if ($this->_id)
		{
			// Make sure we have a user id to checkout the article with
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			// Lets get to it and checkout the thing...
			$weblink = & $this->getTable('subscr');
			if(!$weblink->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}
	function isCheckedOut( $uid=0 )
	{
		if ($this->_loadData())
		{
			if ($uid) {
				return ($this->_data->checked_out && $this->_data->checked_out != $uid);
			} else {
				return $this->_data->checked_out;
			}
		}
	}

	function store($data)
	{

		$row =& $this->getTable('subscr');

		// Bind the form fields to the web link table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			//echo "1111"; exit;
			return false;
		}
		// if new item, order last in appropriate group
		$sql = "SELECT * FROM #__jcs_plans WHERE id = ".$row->subscription_id;
		$this->_db->setQuery($sql);
		$item = $this->_db->loadObjectList();
		$item = $item[0];
		
		if (!$row->id) {
			switch($item->days_type)
			{
				case "weeks";
				$offset = ($item->days * 7) * 86400;
				break;

				case "months";
				$offset = ($item->days * 30) * 86400;
				$offset = mktime(date('H'),date('i'), date('s'),(date('m') + $item->days),date('d'), date('Y')) - time();
				break;

				case "years";
				$offset = ($item->days * 365) * 86400;
				break;

				case "hours";
				$offset = $item->days * 3600;
				break;

				default:
					$offset = $item->days * 86400;
			}

			$this->_db->setQuery("SELECT NOW()");
			$now = $this->_db->loadResult();

			$row->created = $now;
			$row->access_limit = $row->access_limit ? $row->access_limit : $item->time_limit;
			//$row->gateway_id = time();
			$row->price = $item->price;

			$sql = "
			SELECT id, extime, IF(NOW() > extime , 1, 0) AS expire
			FROM #__jcs_user_subscr
			WHERE user_id = $row->user_id
			AND subscription_id = $row->subscription_id
			ORDER BY extime DESC
        	";
			$this->_db->setQuery( $sql );
			$us = $this->_db->loadObject();
			//print_r($us); exit();
			//$us = $us[0];
			if(!is_object($us) || ($us->expire) || ($item->time_limit > 0))
			{
				$row->ctime =  $now;
				$row->extime = $this->getMySQLDate($now, $offset);
			}
			else
			{
				$row->ctime =  $us->extime;
				$row->extime = $this->getMySQLDate($us->extime, $offset);
			}
			//echo $row->ctime;

			if(isset($data['parent']) && $data['parent'] > 0)
			{
				$row->parent = $data['parent'];
			}
			if(isset($data['extime']) && $data['extime'] > 0)
			{
				$row->extime = $data['extime'];
			}

			$plan_param = new JParameter($item->params);
			if($plan_param->get('cp_plans'))
			{
				if($ctime = $this->getCrossPeriod($row->subscription_id, $plan_param->get('cp_plans').','.$row->subscription_id, $row->user_id))
				{
					$row->ctime = $ctime;
					$row->extime = $this->getMySQLDate($row->ctime, $offset);
				}
			}

			if($plan_param->get('date_from', 0))
			{
				$row->ctime = $plan_param->get('date_from');
				$row->extime = $this->getMySQLDate($row->ctime, $offset);
			}
			if($plan_param->get('date_to', 0))
			{
				$row->extime = $plan_param->get('date_to');
			}

			if(isset($data['auto_parent']))
			{
				$row->ctime = $data['ctime'];
				$row->extime = $data['extime'];
				$row->never_activated = 1;
				$row->price = $item->price;
			}

			if(($item->gid > 0) && ($row->published == 1))
			{
				//echo "Here";
				$query = "SELECT lft FROM  #__core_acl_aro_groups
				where id = '{$item->gid}'";
				$this->_db->setQuery( $query );
				$newl = $this->_db->loadResult();
				//echo " New".$newl;
				$query = "
				SELECT g.lft FROM #__core_acl_aro_groups AS g
				LEFT JOIN #__users AS u ON u.gid = g.id
				WHERE u.id = '{$row->user_id}'";
				$this->_db->setQuery( $query );
				$oldl = $this->_db->loadResult();
				//echo " Old".$oldl;

				if($newl >= $oldl){
					$query = "UPDATE #__users SET gid = '{$item->gid}',
					usertype = '{$item->usertype}' WHERE id  = '{$row->user_id}'";
					$this->_db->setQuery( $query );
					$this->_db->query();

					// update the ACL
					$query = "SELECT id"
					. "\n FROM #__core_acl_aro"
					. "\n WHERE value = " . (int) $row->user_id
					;
					$this->_db->setQuery( $query );
					$aro_id = $this->_db->loadResult();


					$query = "UPDATE #__core_acl_groups_aro_map"
					. "\n SET group_id = $item->gid"
					. "\n WHERE aro_id = $aro_id"
					;

					$this->_db->setQuery( $query );
					$this->_db->query() or die( $this->_db->stderr() );
					//echo $this->_db->getQuery();exit;
				}
			}
		}

		//echo $this->getMySQLDate(date('Y-m-d H:i:s'), $days);
		//Exit;



		// Make sure the web link table is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if($item->auto_child_plans != '')
		{
			$childs = explode(',', $item->auto_child_plans);
			$row_child = & JTable::getInstance('subscr', 'Table');
			$i = 0;
			foreach ($childs as $child )
			{
				$res['subscription_id'] = $child;
				$res['gateway'] = '.auto_content';
				$res['gateway_id'] = time() + $i;
				$res['user_id'] = $row->user_id;
				$res['pay'] = 'fail';
				$res['auto_parent'] = $row->subscription_id;


				switch($plan_param->get('auto_activate_in_type'))
				{
					case "weeks";
					$offset = ($plan_param->get('auto_activate_in') * 7) * 86400;
					break;

					case "months";
					$offset = ($plan_param->get('auto_activate_in') * 30) * 86400;
					$offset = mktime(date('H'),date('i'), date('s'),(date('m') + $plan_param->get('auto_activate_in')), date('d'), date('Y')) - time();
					break;

					case "years";
					$offset = ($plan_param->get('auto_activate_in') * 365) * 86400;
					break;

					case "hours";
					$offset = $plan_param->get('auto_activate_in') * 3600;
					break;

					default:
						$offset = $plan_param->get('auto_activate_in') * 86400;
				}
					
				$res['ctime'] = $this->getMySQLDate($row->ctime, ($offset * $i) );


				if($plan_param->get('auto_child_finish'))
				{
					$res['extime'] = $row->extime;
				}
				else
				{
					$res['extime'] = $this->getMySQLDate($res['ctime'], $offset );
				}

				$this->store($res);
				$i ++;
			}
		}
		
		// AngelDesk Integration
		$params = new JParameter($item->params);
		$ids = preg_replace("#[^0-9,]#iU", '', $params->get('ad_ids'));
		if(JCS_AD_ENABLE && JCS_AD_SECRET_WORD && $ids)
		{
			$soap = new SoapClient('https://angeldeskws.com/v1/public/api/adws.wsdl');
			$ids = explode(',', $ids);
			$user = JUser::getInstance($row->user_id);
			
			$p = $params->get('ad_period');
			if($p)
			{
				$period = strtotime($row->ctime) + ($p * 86400);
				
				if(substr($p, 0, 5) == 'date:')
				{
					$period = strtotime(preg_replace("#[^0-9\-\:\ ]#iU", '', str_replace('date:', '', $p)));
				}
				
			}
			else 
			{
				switch($item->days_type)
				{
					case 'hours':
						$x = 3600;
						break;
					case 'days':
						$x = 1 * 86400;
						break;
					case 'weeks':
						$x = 7 * 86400;
						break;
					case 'months':
						$x = 30 * 86400;
						break;
					case 'years':
						$x = 365 * 86400;
						break;
				}
				$period = strtotime($row->ctime) + ($item->days * $x); 
			}
			
			foreach ($ids AS $id)
			{
				$key = md5($user->get('email').$id.'1'.$period.JCS_AD_SECRET_WORD);
				$result = json_decode(@$soap->paidAccessCallback($user->get('email'), $id, 1, $period, $key));
				
				if($result == 'Ok!')
				{
					JError::raiseNotice(100, 'AngelDesk query successfull');
				}
				else 
				{
					JError::raiseWarning(100, 'AngelDesk query error: '. $result);
				}
				
			}
		}
		// end AngelDesk integration

		$this->id = $row->id;

		return true;
	}
	function getMySQLDate($start, $offset, $type = 'SECOND')
	{
		$db = & Jfactory::getDBO();
		$sql = "SELECT '{$start}' + INTERVAL {$offset} {$type}";
		$db->setQuery($sql);
		return $db->loadResult();
	}
	function delete($cid = array())
	{
		$result = false;

		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'SELECT s.user_id, UNIX_TIMESTAMP(s.ctime) AS ctime, p.days, p.params, p.days_type FROM #__jcs_user_subscr AS s LEFT JOIN #__jcs_plans AS p ON p.id = s.subscription_id'
			. ' WHERE s.id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			$subscr = $this->_db->loadObjectList();
			settype($subscr, 'array');
			
			
			
			foreach ($subscr AS $s)
			{
				// AngelDesk Integration
				$params = new JParameter($s->params);
				$ids = preg_replace("#[^0-9,]#iU", '', $params->get('ad_ids'));
				if(JCS_AD_ENABLE && JCS_AD_SECRET_WORD && $ids)
				{
					$soap = new SoapClient('https://angeldeskws.com/v1/public/api/adws.wsdl');
					$ids = explode(',', $ids);
					$user = JUser::getInstance($s->user_id);
					
					foreach ($ids AS $id)
					{
						$key = md5($user->get('email').$id.'0'.'0'.JCS_AD_SECRET_WORD);
						$result = json_decode(@$soap->paidAccessCallback($user->get('email'), $id, 0, 0, $key));
						if($result == 'Ok!')
						{
							JError::raiseNotice(100, 'AngelDesk query successfull');
						}
						else 
						{
							JError::raiseWarning(100, 'AngelDesk query error: '. $result);
						}
					}
				}
				// end AngelDesk integration
			}
			
			$query = 'DELETE FROM #__jcs_user_subscr'
			. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if(!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			
		}

		return true;
	}
	function checkin()
	{
		if ($this->_id)
		{
			$weblink = & $this->getTable('subscr');
			if(! $weblink->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}
	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = 'SELECT up.*, p.name as pname, u.name as uname, u.id as uid, p.id as pid'.
			' FROM #__jcs_user_subscr AS up' .
			' LEFT JOIN #__jcs_plans AS p ON p.id = up.subscription_id' .
			' LEFT JOIN #__users AS u ON u.id = up.user_id' .
			' WHERE up.id = '.(int) $this->_id;
			$this->_db->setQuery($query);
			//echo $query;
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}
	function &getSubscription()
	{
		// Load the weblink data
		if ($this->_loadData())
		{
			// Initialize some variables
			$user = &JFactory::getUser();

			// Check to see if the category is published
		}
		else  $this->_initData();

		return $this->_data;
	}

	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$sub->id          = NULL;
			$sub->user_id     = 0;
			$sub->ctime       = null;
			$sub->published   = 0;
			$sub->extime =    null;
			$sub->price       = 0.00;
			$sub->number      = 0;
			$sub->access_count= 0;
			$sub->access_limit= 0;
			$sub->gateway     = ".undefined";
			$sub->gateway_id  = 0;
			$sub->created     = null;
			$sub->checked_out = 0;
			$sub->checked_out_time = null;
			$sub->subscription_id  = 0;

			$this->_data					= $sub;
			return (boolean) $this->_data;
		}
		return true;
	}

	function sendEmail($data, $activate)
	{
		$config = JFactory::getConfig();
		jimport('joomla.mail.mail');
		jimport('joomla.mail.helper');
		$subject = ($activate==1) ? JText::_("GENERAL_ALERT_ACTIVATE_SUBJ") : JText::_("GENERAL_ALERT_DEACTIVATE_SUBJ");
		$subject = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $subject);
		$sender[0] = $config->getValue('config.mailfrom');
		$sender[1] = $config->getValue('config.fromname');
		foreach($data as $val)
		{
			$mail = JFactory::getMailer();
			$body = ($activate==1) ? JText::_("GENERAL_ALERT_ACTIVATE") : JText::_("GENERAL_ALERT_DEACTIVATE");
			$body = str_replace('[USER]', $val->name, $body);
			$body = str_replace('[SUBSCR_NAME]', '"'.$val->subscr.'"', $body);
			$body = str_replace('[ORDER_ID]', $val->gateway_id, $body);
			$body = str_replace('[SITE_NAME]', $config->getValue('config.sitename'), $body);
			$body = str_replace('[SITE_URL]', JURI::root(), $body);
			$mail->setSender($sender);
			$mail->AddAddress($val->email);
			if ( JString::strlen($body) != JString::strlen(strip_tags($body)))
			$mail->IsHTML(true);
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($subject));
			$mail->Send();
		}
	}

	function grantPlans($parent)
	{
		$sql = "SELECT params FROM #__jcs_plans WHERE id ='".$parent['subscription_id']."'";
		$this->_db->setQuery($sql);
		$result = $this->_db->loadResult();
		$params = new JParameter( $result );
		$plans = $params->get('plans_grant');
		if($plans != '')
		{
			settype($plans, 'array');
			foreach($plans as $k=>$plan)
			{
				$res = array('gateway' => '.granted', 'gateway_id' => $parent['gateway_id'], 'user_id' => $parent['user_id'], 'price' => 0,
				'published' => 1 );
				$res['subscription_id'] = $plan;
				$this->store($res);
			}
		}
		return true;
	}

	function getCrossPeriod($sid, $plans, $uid)
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT extime FROM #__jcs_user_subscr WHERE subscription_id IN ({$plans}) AND user_id = '$uid'
		AND published = '1' AND extime > NOW()
		ORDER BY extime DESC LIMIT 1";
		$db->setQuery($sql);
		if($res = $db->loadResult())
		return $res;
		else
		return false;
	}

	function getSubscriptionCouponInfo($sid)
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT ch.price, ch.discount, ch.discount_type, cc.value, cc.id
		FROM #__jcs_coupons_history ch
		LEFT JOIN #__jcs_coupons cc ON cc.id = ch.coupon_id
		WHERE ch.subscription_id = '$sid'";
		$db->setQuery($sql);
		return $db->loadObject();
	}

}
?>
