<?php
/**
 * $Id: view.html.php 7585 2011-12-05 06:42:18Z alfiya $
 * $LastChangedDate: 2011-12-05 12:42:18 +0600 (Mon, 05 Dec 2011) $
 * $LastChangedBy: alfiya $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('restricted');

jimport( 'joomla.application.component.view');

class JcsViewJcs extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;
		$model  =& $this->getModel();


		if($this->getLayout() == 'form') {
			print $tpl;
			$this->_displayForm($tpl);
			return;
		}
		if($this->getLayout() == 'about') {
			$this->_showAbout($tpl);
			return;
		}
		// Set toolbar items for the page
		JToolBarHelper::title(   JText::_( 'Subscription Plans' ), 'generic.png' );
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList(JText::_( 'Are you sure you want to delete selected plans?' ));
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();

		$bar = & JToolBar::getInstance('toolbar');
		$bar->addButtonPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'library');
		$bar->appendButton( 'JSHelp',  'http://help.mightyextensions.com/member/subscription_plans.htm', 1000, 500 );
		//JToolBarHelper::help( 'screen.weblink' );

		$db		=& JFactory::getDBO();
		$uri	=& JFactory::getURI();

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'filter_state',		'filter_state',		'',				'word' );
		$filter_catid		= $mainframe->getUserStateFromRequest( $option.'filter_catid',		'filter_catid',		0,				'int' );
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

		// Get data from the model
		$items		= & $this->get( 'Data');
		$total		= & $this->get( 'Total');
		$pagination = & $this->get( 'Pagination' );

		foreach ($items as $i => $item)
		{
			$items[$i]->sub_published = $model->getSubscribersByType($item->id, 'published');
			$items[$i]->sub_unpublished = $model->getSubscribersByType($item->id, 'unpublished');
			$items[$i]->sub_expired = $model->getSubscribersByType($item->id, 'expired');
		}

		// build list of categories
		$javascript 	= 'onchange="document.adminForm.submit();"';
		$lists['catid'] = JHTML::_('list.category',  'filter_catid', 'com_jcs', intval( $filter_catid ), $javascript );

		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search']= $search;

		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('lists',		$lists);
		$this->assignRef('items',		$items);
		$this->assignRef('pagination',	$pagination);
		$this->assignRef('request_url',	$uri->toString());

		parent::display($tpl);
	}
	function _displayForm($tpl)
	{
		global $mainframe, $option;

		$db     =& JFactory::getDBO();
		$uri    =& JFactory::getURI();
		$user   =& JFactory::getUser();
		$model  =& $this->getModel();

		$lists = array();
		$isJSC = is_dir(JPATH_ROOT.DS.'components'.DS.'com_resource');

		//get the weblink
		$plan	=& $this->get('data2');
		//$plan = $plan[0];
		//print_r($plan);
		//echo $plan->name;
		$isNew = ($plan->id < 1);

		// fail if checked out not by 'me'
		if ($model->isCheckedOut( $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( 'The Plan' ), $plan->name );
			$mainframe->redirect( 'index.php?option='. $option, $msg );
		}

		// Set toolbar items for the page
		$text = $isNew ? JText::_( 'New' ) : JText::_( 'Edit' );
		JToolBarHelper::title(   JText::_( 'Subscription Plan' ).': <small><small>[ ' . $text.' ]</small></small>' );
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}
		//JToolBarHelper::help( 'screen.weblink.edit' );

		// Edit or Create?
		if (!$isNew)
		{
			$model->checkout( $user->get('id') );
		}
		else
		{
			// initialise new record
			$plan->published = 1;
			//$weblink->approved 	= 1;
			$plan->order 	= 0;
			$plan->catid 	= JRequest::getVar( 'catid', 0, 'post', 'int' );
		}


		// build the html select list for ordering
		$query = 'SELECT ordering AS value, name AS text'
		. ' FROM #__jcs_plans'
		. ' WHERE catid = ' . (int) $plan->catid
		. ' ORDER BY ordering';
		$lists['ordering'] 			= JHTML::_('list.specificordering',  $plan, $plan->id, $query, 1 );

		// build list of categories
		$lists['catid'] 			= JHTML::_('list.category',  'catid', 'com_jcs', intval( $plan->catid ) );
		// build the html select list
		$lists['published']   = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $plan->published );
		$lists['categories']  = $model->_categoryList($plan->category);

		$lists['components']  = $model->_componentList($plan->component, $plan->params);

		$lists['plans_list']  = $model->_plansList('req_plans', $plan->cross_plans, $plan->id);
		//$lists['plans_list']  = $model->_plansList($plan->cross_plans, $plan->id);


		$params = new JParameter($plan->params);

		$lists['cross_period_plans']  = $model->_plansList('cp_plans', $params->get('cp_plans'), $plan->id);


		$alerts = new JParameter($plan->alerts);

		$API = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
		if(file_exists($API))
		{
			require_once $API;
			if(class_exists('JSCommunityApi')) $capi = new JSCommunityApi(); else $capi = new stdClass();
			if(method_exists($capi, 'getCarmaList')) $karmalist = $capi->getCarmaList();

			$kdiscount = explode("\n", $params->get('karma_discount', ''));
			foreach ($kdiscount as $k=> $type)
			{
				$tmp = explode("::", $type);
				$kdiscount[$k] = $tmp[0].'::';
			}

			foreach($karmalist as $k => $type)
			{
				$karmalist[$k] = $type['title'].'('.$type['points'].')::';
			}

			$diff = array_diff($karmalist, $kdiscount);
			$karma_disc = $params->get('karma_discount').( count($diff) ? ( $params->get('karma_discount') ? '\n' : '').implode('\n', $diff) : '' );
			$lists['karma_discount'] = '<textarea name="karma_discount" rows="'.(count($kdiscount) + count($diff)).'" cols="24">'.$karma_disc.'</textarea>';
		}
		else
		$lists['karma_discount'] = '<b>This feature works only if
		<a href="http://www.mightyextensions.com/joomla-components/peopletouch-community-social-network-service" target="_blank">Mighty Touch</a> is installed</b>
			<input type="hidden" name="karma_discount" value="0">';

		$opt = array();
		$opt[] = JHTML::_('select.option', 1, JText::_('Set start day on payment date'), 'id', 'title' );
		$opt[] = JHTML::_('select.option', 2, JText::_('Set start day on the end of existing subscription'), 'id', 'title' );
		$lists['cl_period']   = JHTML::_('select.genericlist', $opt, 'cl_period', 'class="inputbox"', 'id', 'title',  $params->get('cl_period', '1'));

		/*$opt = array();
		 $opt[] = JHTML::_('select.option', 0, JText::_("Set cross plan's start day on payment date"), 'id', 'title' );
		 $opt[] = JHTML::_('select.option', 1, JText::_("Set cross plan's start day on the end of this subscription"), 'id', 'title' );
		 $lists['cross_period']   = JHTML::_('select.genericlist', $opt, 'cross_period', 'class="inputbox"', 'id', 'title',  $params->get('cross_period', '0'));
		 */


		$method = array("or" => JText::_("Subtract most expensive of selected"), "and"=> JText::_("Subtract sum of all selected"), "none" => JText::_("leave as is"));
		$opt = array();
		foreach($method AS $k=>$val)
		{
			$opt[] = JHTML::_('select.option', $k, $val, 'id', 'title' );
		}
		$lists['method']   = JHTML::_('select.genericlist', $opt, 'method', 'class="inputbox"', 'id', 'title', $params->get('calculate_method', 'none') );

		$opt = array();
		$required = array("No", "Yes OR", "Yes AND");
		$required_tip = array(JText::_('Cross plans are not required'), JText::_("To get this subscription user must have one of the selected cross plans"),
		JText::_("To get this subscription user must have all selected cross plans"),
						'deactivate' => JText::_("Purchasing this plan all selected cross subcriptions will be deactivated"));
		foreach($required AS $k => $val)
		{
			$opt[] = JHTML::_('select.option', $k, '<span class="hasTip" title="'.$required_tip[$k].'">'.$val.'</span>', 'id', 'title' );
		}
		$lists['required']   = JHTML::_('select.radiolist', $opt, 'required', 'class="inputbox"', 'id', 'title', $params->get('required', 0) );
		//$lists['required']   = JHTML::_('select.booleanlist', 'required', 'class="inputbox"', $params->get('required') );

		$lists['plans_grant']  = $model->_plansList('grant_plans', $params->get('plans_grant'), $plan->id);
		//$lists['plans_grant']  = $model->_plansGrantList($params->get('plans_grant'), $plan->id);
		$lists['show_plans_grant']  = JHTML::_('select.booleanlist', 'show_grant', 'class="inputbox"', $params->get('show_plans_grant', 1) );

		$lists['plans_deactivate']  = $model->_plansList('plans_deactivate', $params->get('plans_deactivate'), $plan->id);
		//$lists['deactivate']  = JHTML::_('select.booleanlist', 'deactivate', 'class="inputbox"', $params->get('deactivate', 0) );

		$lists['gid']  = $model->_groupList($plan->gid);
		$lists['congrat']  = $model->_pagesList($plan->granturl);
		$lists['invisible']   = JHTML::_('select.booleanlist', 'invisible', 'class="inputbox"', $plan->invisible );
		$lists['strict']   = JHTML::_('select.booleanlist', 'data_fixed', 'class="inputbox"', $plan->data_fixed );
		$lists['grant_old']   = JHTML::_('select.booleanlist', 'grant_reg', 'class="inputbox"', $plan->grant_reg );
		$lists['grant_new']   = JHTML::_('select.booleanlist', 'grant_new', 'class="inputbox"', $plan->grant_new );
		$lists['limit']   = JHTML::_('select.booleanlist', 'one_time', 'class="inputbox"', $plan->one_time );
		$lists['alert']   = JHTML::_('select.booleanlist', 'alert_admin', 'class="inputbox"', $plan->alert_admin );
		$lists['alert_user']   = JHTML::_('select.booleanlist', 'alert_user', 'class="inputbox"', $params->get('alert_user', 1) );
		$lists['redirect']   = '<input type="text" name="redirect" class="inbox" size="50" value="'.$params->get('redirect', '').'">';

		$lists['muaccess'] = '<input type="text" name="muaccess" class="inbox" maxlength="10" size="10" value="'.$params->get('muaccess', 0).'">';
		$is_jsinbox_exist = is_dir(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox');
		if( $is_jsinbox_exist ){

			$lists['mua_msg_type'] = $model->MuaInboxTypeList($params->get('mua_msg_type'));
		}

		$lists['karma'] = '<input type="text" name="karma" class="inbox" maxlength="10" size="10" value="'.$params->get('karma', 3).'">';
		if(!file_exists($API))
		{
			$lists['karma'] .= '<b>This feature works only if
		<a href="http://www.mightyextensions.com/joomla-components/peopletouch-community-social-network-service" target="_blank">Mighty Touch</a> is installed</b>
			';
		}
		$lists['jsc_category'] = null;
		if($isJSC )
		{
			$sql = "SELECT contentcategory AS value FROM #__jcs_plans WHERE id = ".(int)$plan->id;
			$db->setQuery($sql);
			$def = $db->loadObjectList();
			$def = @explode(",", $def[0]->value);
			if($def){
				foreach($def AS $ct)
				{
					$selected[]->id = $ct;
				}
			}

			require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
			ResControllerConfig::initialyze();
			if(defined('RES_CATEGORIES_VIEW') && RES_CATEGORIES_VIEW == 'tree')
			{
				require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
				require_once (JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'resource.xajax.php');
				$lists['jsc_category'] = ResHelper::getAjaxTreeCategoryList(0, $def, 1, '', 'jsc_category');
			}
			else
			{
				JModel::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'models');
				$jsc_model = JModel::getInstance('category', 'ResModel');
				$categories = $jsc_model->_getCategoriesList();
				if(count($categories) > 7) $n = 7;
				else $n = count($categories);

				if($categories)
				{
					$lists['jsc_category'] = @JHTML::_('select.genericlist', $categories,
					'jsc_category[]', ' multiple="multiple" class="inputbox" size="'.$n
					.'" ', 'value', 'text', $def);
				}
			}
		}
		$opt = array();
		$opt[] = JHTML::_('select.option', 'text', JText::_('Text'), 'id', 'title' );
		$opt[] = JHTML::_('select.option', 'html', JText::_('Html'), 'id', 'title' );

		$lists['send_as']   = JHTML::_('select.radiolist', $opt, 'send_as', 'class="inputbox"', 'id', 'title', $params->get('send_as', 'text') );

		$lists['msg_successful'] = $alerts->get('msg_successful', str_replace("\n", "<br>", JText::_('GENERAL_ALERT_SUCCESS')));
		$lists['msg_fail'] = $alerts->get('msg_fail', str_replace("\n", "<br>", JText::_('GENERAL_ALERT_FAIL')));
		$lists['msg_expiration'] = $alerts->get('msg_expiration', str_replace("\n", "<br>", JText::_('GENERAL_ALERT_EXPIRE')));

		$opt = array();
		$opt[] = JHTML::_('select.option', '00Sign', '00Sign', 'id', 'title' );
		$opt[] = JHTML::_('select.option', 'Sign00', 'Sign00', 'id', 'title' );
		$opt[] = JHTML::_('select.option', '00 Sign', '00 Sign', 'id', 'title' );
		$opt[] = JHTML::_('select.option', 'Sign 00', 'Sign 00', 'id', 'title' );
		$lists['layout_price']   = JHTML::_('select.genericlist', $opt, 'layout_price', 'class="inputbox"', 'id', 'title', $params->get('layout_price', JCS_LAYOUT_PRICE) );

		JHTML::_('behavior.calendar');
		$lists['date_from'] = JHTML::_('calendar', $params->get('date_from') , 'date_from', 'ctime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));
		$lists['date_to'] = JHTML::_('calendar', $params->get('date_to') , 'date_to', 'extime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));
		$lists['ad_ids'] = JRequest::getVar('ad_ids', $params->get('ad_ids'));
		$lists['ad_period'] = JRequest::getVar('ad_period', $params->get('ad_period', 0));


		$lists['child_plans'] = $model->_AutoChildPlans((isset($plan->auto_child_plans) ? $plan->auto_child_plans : ''), $plan->id);
		$option = array('hours', 'days', 'weeks', 'months', 'years');
		$opt = array();
		foreach ($option as $val)
		{
			$opt[] = JHTML::_('select.option', $val, JText::_(ucfirst($val)), 'id', 'value' );
		}
		$lists['activate_in_type'] = JHTML::_('select.genericlist', $opt, 'activate_in_type', 'class="inputbox"', 'id', 'value', $params->get('auto_activate_in_type') );
		$lists['child_finish']   = JHTML::_('select.booleanlist', 'auto_child_finish', 'class="inputbox"', $params->get('auto_child_finish', 1) );

		$lists['invisible_in_history']   = JHTML::_('select.booleanlist', 'invisible_in_history', 'class="inputbox"', isset($plan->invisible_in_history) ? $plan->invisible_in_history : 0 );


		JFilterOutput::objectHTMLSafe( $plan );

		$params = new JParameter($plan->params, JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jcs'.DS.'params.xml');

		$editor =& JFactory::getEditor();
		$this->assignRef('js_strict',$params->get('js_strict'));
		$this->assignRef('lists',	 $lists);
		$this->assignRef('plan',   $plan);
		$this->assignRef('editor', $editor);
		$this->assignRef('params', $params);
		$this->assignRef('alerts', $alerts);
		$this->assignRef('request_url',	$uri->toString());
		$this->assign('isJSC',	$isJSC);
		parent::display($tpl);
	}

	function _showAbout($tpl = null)
	{
		JToolBarHelper::title(   JText::_( 'MightyExtensions About' ), 'generic.png' );
		$file = JPATH_COMPONENT_ADMINISTRATOR.DS.'com_jcs.xml';
		$file2 = JPATH_COMPONENT_ADMINISTRATOR.DS.'update_com_jcs.xml';
		if(JFile::exists($file2)) $file = $file2;

		$data = JApplicationHelper::parseXMLInstallFile($file);
		$this->assignRef('data', $data);

		parent::display($tpl);
	}
}
?>