<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('restricted');

jimport( 'joomla.application.component.view');

class JcsViewUsers extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;

		if($search = JRequest::getVar('user_search'))
		{
			JRequest::setVar('layout', 'form'  );
		}
		if($this->getLayout() == 'form') {
			$this->_displayForm($tpl);
			return;
		}

		// Set toolbar items for the page
		JToolBarHelper::title(   JText::_( 'User Subscriptions' ), 'generic.png' );
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList(JText::_( 'Are you sure you want to delete selected subscriptions?' ));
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		

		$bar = & JToolBar::getInstance('toolbar');
		$bar->addButtonPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'library');
		$bar->appendButton( 'JSHelp',  'http://help.mightyextensions.com/member/user_subscriptions.htm', 1000, 500 );

		//JToolBarHelper::help( 'screen.weblink' );

		$db		=& JFactory::getDBO();
		$uri	=& JFactory::getURI();

		$users_model = &JModel::getInstance('Users','JcsModel');
		$this->setModel($users_model);

		$model  =& $this->getModel('users');

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'users.filter_state',		'filter_state',		'',				'word' );
		$filter_plans		= $mainframe->getUserStateFromRequest( $option.'users.filter_plans',		'subscription_id',		0,	'int' );
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'users.filter_order',		'filter_order',		'up.created',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'users.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'users.search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

		// Get data from the model
		$items      = & $this->get('Data','users');
		$total      = & $this->get('Total','users');
		$pagination = & $this->get('Pagination','users' );

		$edit_profile_link = "index.php?option=com_users&view=user&task=edit&cid[]=";
		$juser_path = JPATH_ADMINISTRATOR.DS."components".DS."com_juser".DS."admin.juser.php";
		if(file_exists($juser_path))
		{
			$edit_profile_link = "index.php?option=com_juser&task=edit&cid[]=";
		}
		//$items      = & $model->getData;
		//$total      = & $model->getTotal;
		//$pagination = & $model->getPagination;
		
		foreach ($items as $i => $val)
		{
			$items[$i]->coupon_info = $model->getSubscriptionCouponInfo($val->id);
		}


		// build list of Plans
		$lists['plan'] = $model->getPlans($filter_plans);

		$javascript 	= 'onchange="document.adminForm.submit();"';
		//JHTML::_('list.category',  'filter_plan', 'com_jcs_plans', intval( $filter_catid ), $javascript );

		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search']= $search;

		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('lists',		$lists);
		$this->assignRef('items',		$items);
		$this->assignRef('edit_profile_link',		$edit_profile_link);
		$this->assignRef('pagination',	$pagination);
		$this->assignRef('request_url',	$uri->toString());

		parent::display($tpl);
	}
	function _displayForm($tpl)
	{
		global $mainframe, $option;

		$db     =& JFactory::getDBO();
		$uri    =& JFactory::getURI();
		$user   =& JFactory::getUser();
		$model  =& $this->getModel('users');

		$lists = array();

		$plan	=& $this->get('Subscription');
		$isNew = ($plan->id < 1);

		// fail if checked out not by 'me'
		if ($model->isCheckedOut( $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( 'The Plan' ), $plan->name );
			$mainframe->redirect( 'index.php?option='. $option, $msg );
		}

		// Set toolbar items for the page
		$text = $isNew ? JText::_( 'New' ) : JText::_( 'Edit' );
		JToolBarHelper::title(   JText::_( 'User Subscription' ).': <small><small>[ ' . $text.' ]</small></small>' );
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}
		//JToolBarHelper::help( 'screen.weblink.edit' );

		$lists['plan'] = $model->getPlans2($plan->subscription_id);
		if(JRequest::getInt('user_id'))
		{
			$lists['users'] = $this->_userField(JRequest::getInt('user_id'));
		}
		else
		{
			if(JCS_USERLIST_LAYOUT == 'list'){
				$lists['users'] = $model->getUsers($plan->user_id);
			} else {
				if($search = JRequest::getVar('user_search'))
				{
					$lists['users'] = $model->getFindUsers($search, $plan->user_id);
				}
			}
		}
		if (!$isNew)
		{
			$model->checkout( $user->get('id') );
		}
		else
		{
			$plan->published = 1;
		}

		$lists['published']   = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $plan->published );

		jimport('joomla.filter.filteroutput');
		JFilterOutput::objectHTMLSafe( $plan );
		$editor =& JFactory::getEditor();

		if (!$isNew)
		{
			JHTML::_('behavior.tooltip');
			JHTML::_('behavior.calendar');
			$lists['ctime'] = JHTML::_('calendar', $plan->ctime , 'ctime', 'ctime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));
			$lists['extime'] = JHTML::_('calendar', $plan->extime , 'extime', 'extime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));

		}
		$this->assignRef('lists',	 $lists);
		$this->assignRef('isNew',	 $isNew);
		$this->assignRef('plan',   $plan);
		$this->assignRef('editor', $editor);
		$this->assignRef('params', $params);
		$this->assignRef('request_url',	$uri->toString());
		parent::display($tpl);
	}

	function _userField($id)
	{
		$user = JFactory::getUser($id);
		$out = '<input type="hidden" name="user_id" value="%d">(%d) %s';
		$out = sprintf($out, $id, $id, $user->get('name'));
		return $out;
	}
	
	
}
?>