<?php
/**
 * $Id: api.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

/**
 * Member API file
 *
 * To use those functions you need to setup on your side like described here
 * http://joomsuite.com/index.php?option=com_resource&controller=article&article=2823&category_id=45&Itemid=82
 *
 */
class JSMemberApi
{
	function jscCountLimit($plans, $mode)
	{
		// if we should not count
		if($mode == 0) return;

		$user = & JFactory::getUser();
		$db = JFactory::getDBO();

		if (is_array($plans))
		{
			$plans = implode(',', $plans);
		}
		if (! $plans)
		return;

		$query = " SELECT id FROM #__jcs_plans AS s  WHERE s.id IN (" . $plans . ") AND s.published = 1";
		$db->setQuery($query);
		$plans = $db->loadResultArray();

		if (count($plans))
		{
			$plans = implode(',', $plans);
			if($mode == 2)
			{
				$query = "SELECT u.id, IF(u.access_limit > 0, IF(u.access_count >= u.access_limit, 0, 1), 1) AS cl
					FROM #__jcs_plans AS s 
					LEFT JOIN #__jcs_user_subscr AS u ON s.id = u.subscription_id
				   WHERE s.id IN (" .$plans . ")
	                 AND u.user_id = " . $user->get('id') . "
	                 AND u.extime > NOW()
	                 AND u.ctime < NOW()
	                 AND u.published = 1
	               GROUP BY s.id
	              HAVING cl > 0
	               ORDER BY u.ctime LIMIT 1";
				//echo $query; Exit;
				$db->setQuery($query);
				if ($res = $db->loadObject())
				{
					$sql = "UPDATE #__jcs_user_subscr SET access_count = access_count + 1 WHERE id = {$res->id}";
					$db->setQuery($sql);
					$db->query();
				}
			}
			if($mode == 1)
			{
				$url = & JFactory::getURI();

				$sql  = 'SELECT subscription_id AS sid FROM #__jcs_history WHERE user_id = '.$user->get('id');
				$sql .= ' AND subscription_id IN ('.$plans.') ';
				$sql .= ' AND url = \''.$db->getEscaped($url->toString()).'\'';
				$db->setQuery($sql);
				$res = $db->loadResult();
				//echo $res; exit;
				if (!$res)
				{
					$query = "SELECT u.id, s.id as sid, IF(u.access_limit > 0, IF(u.access_count >= u.access_limit, 0, 1), 1) AS cl
					FROM #__jcs_plans AS s 
					LEFT JOIN #__jcs_user_subscr AS u ON s.id = u.subscription_id
				   WHERE s.id IN (" . $plans . ")
	                 AND u.user_id = " . $user->get('id') . "
	                 AND u.extime > NOW()
	                 AND u.ctime < NOW()
	                 AND u.published = 1
	               GROUP BY s.id
	              HAVING cl > 0
	               ORDER BY u.ctime LIMIT 1";
					$db->setQuery($query);
					$res = $db->loadObject();

					//print_r($res);exit;

					$sql = "UPDATE #__jcs_user_subscr SET access_count = access_count + 1 WHERE id = {$res->id}";
					$db->setQuery($sql);
					$db->query();

					$sql = "INSERT INTO #__jcs_history VALUES(NULL, ".$user->get('id').", '".$db->getEscaped($url->toString())."', NOW(), {$res->sid})";
					$db->setQuery($sql);
					$db->query();

				}
			}
		}
	}
	/**
	 * This function check if user have subscriptions required.
	 * Example of usage
	 *
	 * if($params->get('plans'))
	 * {
	 * 		jscCheckSubscription($params->get('plans'),
	 * 			JText::_('You need subscription to access this page'),
	 * 			$itemid, true, $params->get('count_mode'))
	 * }
	 *
	 * Where $params->get('plans') and $params->get('count_mode') are parameters that
	 * is set using method described here
	 * http://joomsuite.com/index.php?option=com_resource&controller=article&article=2823&category_id=45&Itemid=82
	 *
	 * @param mixed 	$plans 	may be string 12,23,1,3 or array of IDs of plans set
	 * 							to restrict something
	 * @param string 	$msg 	Message to desplay on subscription form
	 * @param integer 	$itemid Itemid of subscription page
	 * @param boolean 	$redirect Redirect to subscription if access restricted or
	 * 							return true or false
	 * @param integer 	$mode	Count limit mode
	 * @return boolean
	 */
	function jscCheckSubscription($plans, $msg, $itemid, $redirect = true, $mode = 0)
	{
		global $mainframe;

		$user = & JFactory::getUser();
		$db = JFactory::getDBO();
		$url = & JFactory::getURI();
		//echo $plans;
		if (is_array($plans))
		{
			$plans = implode(',', $plans);
		}
		if (! $plans)
		return false;
		$query = "SELECT id FROM #__jcs_plans AS s WHERE s.id IN (" . $plans . ") AND s.published = 1";
		$db->setQuery($query);
		$plans = $db->loadResultArray();

		if (count($plans))
		{
			$query = "
			SELECT u.*, IF(u.access_limit > 0 AND {$mode} > 0, IF(u.access_count >= u.access_limit, IF({$mode} = 1 AND h.url = '".$db->getEscaped($url->toString())."', 1, 0), 1), 1) AS cl
		          FROM #__jcs_plans AS s 
		     LEFT JOIN #__jcs_user_subscr AS u ON s.id = u.subscription_id 
		    LEFT JOIN #__jcs_history AS h ON h.subscription_id = s.id 
		        WHERE s.id IN (" . implode(',', $plans) . ")
                   AND u.user_id = " . $user->get('id') . "
                   AND u.extime > NOW()
                   AND u.ctime < NOW()
                   AND u.published = 1
                 GROUP BY u.id
	            HAVING cl > 0";
			$db->setQuery($query);

			//echo $db->getQuery();
			//die();

			if (!$db->loadObjectList())
			{
				if ($redirect)
				{
					JError::raiseWarning(403, $msg);
					$mainframe->redirect('index.php?option=com_jcs&layout=form&Itemid=' . $itemid . '&id=' . implode(',', $plans));
				}
				return TRUE;
			}
			else
			{
				return FALSE;
			}
		}
		return FALSE;
	}

	function getUserSubscr($user_id)
	{
		$db = JFactory::getDBO();
		$sql = "SELECT up.id, up.gateway, up.gateway_id, up.access_limit,
		up.published, up.access_count,
		up.price, up.checked_out,
		up.created, up.ctime, up.extime, p.name,
		(TO_DAYS(up.extime) - TO_DAYS(NOW())) as days, p.id AS pid
		FROM #__jcs_user_subscr AS up
		LEFT JOIN #__jcs_plans AS p ON up.subscription_id = p.id
		WHERE up.user_id = '$user_id'";
		$db->setQuery($sql);
		return $db->loadObjectList();
	}
}
?>