<?php
/**
 * $Id: jcs.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

jimport('joomla.application.component.model');
class JcsModelJcs extends JModel
{
	var $_history 		= null;
	var $_plans 			= null;
	var $_cross_plans 			= null;
	var $_processor 	= null;
	var $_total 			= null;
	function __construct()
	{
		parent::__construct();
	}
	//empty($obj->field_value) ? 1 : 1.$obj->field_value
	//JHTML::_('select.booleanlist', "fields[$obj->id]", 1 );
	function getHistory($catid)
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_history))
		{
			$query = $this->_buildQueryHistory($catid);

			$this->_history = $this->_getList($query);
		}

		return $this->_history;
	}

	function _buildQueryHistory($catid)
	{
		$user =& JFactory::getUser();
		$query = "SELECT u.gateway, u.gateway_id, u.id as sid, u.price,
				u.access_limit, u.access_count,
				s.id, s.name , s.description, s.finish_msg, s.catid, s.params,
				u.published, s.invisible, 
    			u.ctime, u.extime,
    			u.extime as nfextime,
    			IF(u.extime < NOW(),0,1) AS ifex,
    			IF(u.ctime <= NOW(), (TO_DAYS(u.extime) - TO_DAYS(NOW())), (TO_DAYS(u.extime) - TO_DAYS(u.ctime)) ) as days, 
    			(TO_DAYS(u.extime) - TO_DAYS(u.ctime))  as days_enable,
    			u.parent, cat.title as category, 
    			IF(u.ctime <= NOW(), 1, 0) as active
    	 	FROM  #__jcs_user_subscr AS u
     		LEFT JOIN  #__jcs_plans AS s ON s.id = u.subscription_id
     		LEFT JOIN #__categories as cat on cat.id = s.catid     		
     		WHERE  u.user_id = ".$user->get('id')."
     		AND s.published = 1
     		AND s.invisible_in_history = '0'";
		/*
		 * DATE_FORMAT(u.ctime, '%d, %b %Y') AS ctime,
		 DATE_FORMAT(u.extime,'%d, %b %Y' ) AS extime,
		 */
		if($catid)
		$query .= " AND s.catid IN ($catid)";
		$query .= " ORDER BY s.catid, u.created DESC, u.id DESC";
		//echo str_replace("#_", "jos", $query);
		return $query;
	}
	function getPlans($id = false)
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_plans))
		{
			$query = $this->_buildQueryPlans($id);
			$this->_plans = $this->_getList($query);
		}

		return $this->_plans;
	}

	function getCrossPlans($ids)
	{
		$query = "SELECT id, name FROM #__jcs_plans WHERE published='1'	AND id IN ($ids)";
		$this->_cross_plans = $this->_getList($query); /* AND invisible='0'*/
		return $this->_cross_plans;
	}

	function getPlanPrice($ids)
	{
		if(!$ids) return;
		$query = "SELECT price FROM #__jcs_plans WHERE published='1' AND id IN ($ids)";
		$this->_cross_plans = $this->_getList($query);
		return $this->_cross_plans;
	}

	function  getUserPlans()
	{
		$user =& JFactory::getUser();
		$db = & JFactory::getDBO();

		$sql = "SELECT p.id AS subs FROM #__jcs_plans AS p
            LEFT JOIN #__jcs_user_subscr AS u ON u.subscription_id = p.id
            WHERE 1
              AND u.user_id = " . $user->get('id') . "
           GROUP BY p.id
              ";
		$db->setQuery( $sql );
		$plans = $db->loadResultArray();
		return $plans;
	}

	function  getUserActivePlans()
	{
		$user =& JFactory::getUser();
		$db = & JFactory::getDBO();
		$sql = "SELECT subscription_id FROM #__jcs_user_subscr
			WHERE published = '1' AND user_id = " . $user->get('id') . "
			GROUP BY subscription_id";
		$db->setQuery( $sql );
		$plans = $db->loadResultArray();
		return $plans;
	}

	function getUserSubscrInfo($sid, $user = false)
	{
		$db = & JFactory::getDBO();

		$sql = "SELECT p.name,  p.params, p.id as plan_id, u.*,
		IF(u.extime < NOW(),0,1) AS ifex,
		IF(u.ctime <= NOW(), 1, 0) as active
		FROM #__jcs_plans AS p
		LEFT JOIN #__jcs_user_subscr AS u ON u.subscription_id = p.id
		WHERE p.published = '1' AND u.id = '$sid'";
		if($user)
		$sql .= " AND u.user_id = '".$user->id."'";
		$db->setQuery( $sql );
		//echo $this->_db->_sql;
		return  $db->loadObject();
	}

	function  getSubscrMUA($sid)
	{
		$db = & JFactory::getDBO();
		$sql = "SELECT sub.*, us.username,
		DATE_FORMAT(sub.ctime, '%d, %b %Y') AS ctime,
		DATE_FORMAT(sub.extime,'%d, %b %Y' ) AS extime,
		IF(sub.extime < NOW(),0,1) AS ifex
		FROM #__jcs_user_subscr as sub
		JOIN #__users us ON sub.user_id = us.id
		WHERE sub.parent = '$sid'";
		$db->setQuery( $sql );
		return  $db->loadObjectList();
	}

	function _buildQueryPlans($id)
	{
		$user = JFactory::getUser();
		$access = (int) $user->get('aid', 0);
		$and = ""; $not = "";
		if(JRequest::getInt('revert', 0) == 1) $not = "NOT";
		if(!is_array($id) && ($id > 0)) settype($id, "array");
		if (is_array($id) && count($id > 0))
		{
			$and = " AND p.id {$not} IN (".implode(" , ", $id).")";

		}
		//else if($id) $and = " AND p.id = '{$id}' "; else $and = "";
			
		$sql = "
		SELECT p.*, c.title AS cname, c.description AS cdescr, c.image as cimage  FROM #__jcs_plans AS p
		LEFT JOIN #__categories AS c ON c.id = p.catid
		WHERE 1 AND p.published = 1
		AND p.invisible = 0 AND c.access <= {$access}
		{$and}
		ORDER BY c.ordering ASC, p.ordering ASC";
		//echo str_replace("#__", "jos_",$sql);
		return $sql;
	}


	function getProcessors()
	{
		if (empty($this->_processor))
		{
			$query = $this->_buildQueryProcessor();
			$this->_processor = $this->_getList($query);

		}

		return $this->_processor;
	}

	function _buildQueryProcessor()
	{
		$sql = "SELECT * FROM #__plugins WHERE `folder` = 'payment' AND published = 1 ORDER BY ordering";
		//echo $sql;
		return $sql;
	}

	function getSubscriptionText($oid)
	{
		$db = & JFactory::getDBO();
		$sql = "SELECT finish_msg FROM #__jcs_plans
		WHERE id = $oid";
		$db->setQuery( $sql );
		return  $db->loadResult();
	}
	function store($data)
	{
		$user = JFactory::getUser();

		$row =& JTable::getInstance('subscr', 'Table');

		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		$sid = explode('::', urldecode($data['sid']));
		$sid = $sid[0];
		$sql = "SELECT id FROM #__jcs_user_subscr
		WHERE gateway_id = '$data[gateway_id]' AND user_id = '$data[user_id]'
		AND gateway = '$data[gateway]' AND subscription_id = '$sid'";
		$this->_db->setQuery($sql);
		//echo $this->_db->_sql;exit();
		$gsid = $this->_db->loadResult();

		if($gsid > 0)
		{
			$this->setError(JText::_( 'Your Subscription Created Successfuly' ));
			return false;
		}
		//$acl = new

		// if new item, order last in appropriate group
		if (!$row->id) {

			$sql = "SELECT * FROM #__jcs_plans WHERE id = ".$sid;
			$this->_db->setQuery($sql);
			$item = $this->_db->loadObjectList();
			$item = $item[0];

			//  PeopleTouch
			$params = new JParameter($item->params);
			$API = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
			if(file_exists($API) && $params->get('karma'))
			{
				require_once $API;
				if(class_exists('JSCommunityApi')) $capi = new JSCommunityApi(); else $capi = new stdClass();
				// saving user's karma in PeopleTouch
				if(method_exists($capi, 'increaseKarma')) $capi->increaseKarma($data['user_id'], $params->get('karma'));
				// -- saving user's karma in PeopleTouch ---------
			}


			// saving user's activity in PeopleTouch
			if(file_exists($API) && JCS_REGISTER_SUB && ($data['pay'] == 'success' || $data['pay'] == 'mua'))
			{
				$act_msg = JText::_('purchased the [SUBSCR] subscription');
				$act_msg = str_replace('[SUBSCR]',
					'<a href="index.php?option=com_jcs&view=jcs&layout=form&id='.$sid.'">"'.$item->name.'"</a>', $act_msg);
				$icon = "administrator/components/com_jcs/images/sidebar/plans.png";
				require_once $API;
				if(class_exists('JSCommunityApi')) $capi = new JSCommunityApi(); else $capi = new stdClass();
				if(method_exists($capi, 'registerActivity'))
				$capi->registerActivity($data['user_id'], $act_msg, $data['user_id'], $icon, 'user', null,  0, 'com_jcs');
					
			}
			// -- saving user's activity in PeopleTouch ---------


			// --  PeopleTouch ---------

			//exit();
			switch($item->days_type)
			{
				case "weeks";
				$offset = ($item->days * 7) * 86400;
				break;

				case "months";
				$offset = ($item->days * 30) * 86400;
				$offset = mktime(date('H'),date('i'), date('s'),(date('m') + $item->days),date('d'), date('Y')) - time();
				break;

				case "years";
				$offset = ($item->days * 365) * 86400;
				break;

				case "hours";
				$offset = $item->days * 3600;
				break;

				default:
					$offset = $item->days * 86400;
			}

			$row->access_limit = $item->time_limit;
			//$row->price = $item->price;
			$row->user_id = $data['user_id'];
			//$row->price = $data['price'];
			$row->subscription_id = $sid;
			

			$sql = "
			SELECT id, extime, IF(NOW() > extime , 1, 0) AS expire
			FROM #__jcs_user_subscr
			WHERE user_id = $row->user_id
			AND subscription_id = $row->subscription_id
			ORDER BY extime DESC
                ";
			$this->_db->setQuery( $sql );
			$us = $this->_db->loadObjectList();
			//print_r($us); exit();
			$us = @$us[0];

			$this->_db->setQuery("SELECT NOW()");
			$now = $this->_db->loadResult();
			$row->created = $now;


			if($item->one_time && $us->id)
			{
				$this->setError('This subscription is available only one time.');
				return false;
			}

			if((count($us) == 0) || (@$us->expire) || ($item->time_limit > 0))
			{
				if($us && $params->get('cl_period') == 2 && !$us->expire)
				{
					$row->ctime  = $us->extime;
					$row->extime = $this->getMySQLDate($us->extime, $offset);
				}
				else
				{
					$row->ctime =  $now;
					$row->extime = $this->getMySQLDate($now, $offset);
				}
			}
			else
			{
				$row->ctime  = $us->extime;
				$row->extime = $this->getMySQLDate($us->extime, $offset);
			}


			if($data['pay'] == 'success')
			{
				$row->published = 1;
			}
			elseif ( $data['pay'] == 'mua')
			{
				$row->published = 1;
			}
			else
			{
				$row->published = 0;
			}
			
			if(isset($data['parent']) && $data['parent'] > 0)
			{
				$row->parent = $data['parent'];
			}
			if(isset($data['extime']) && $data['extime'] > 0)
			{
				$row->extime = $data['extime'];
			}

			$plan_param = new JParameter($item->params);
			if($plan_param->get('cp_plans'))
			{
				if($ctime = $this->getCrossPeriod($row->subscription_id, $plan_param->get('cp_plans').','.$row->subscription_id, $row->user_id))
				{
					$row->ctime = $ctime;
					$row->extime = $this->getMySQLDate($row->ctime, $offset);
				}
			}
			if($plan_param->get('date_from', 0))
			{
				$row->ctime = $plan_param->get('date_from');
				$row->extime = $this->getMySQLDate($row->ctime, $offset);
			}
			if($plan_param->get('date_to', 0))
			{
				$row->extime = $plan_param->get('date_to');
			}

			if(isset($data['auto_parent']))
			{
				$row->ctime = $data['ctime'];
				$row->extime = $data['extime'];
				$row->never_activated = 1;
				$row->price = $item->price;
			}

			if(($item->gid > 0) && ($row->published == 1))
			{
				//echo "Here";
				$query = "SELECT lft FROM  #__core_acl_aro_groups
				where id = '{$item->gid}'";
				$this->_db->setQuery( $query );
				$newl = $this->_db->loadResult();
				//echo " New".$newl;
				$query = "
				SELECT g.lft FROM #__core_acl_aro_groups AS g
				LEFT JOIN #__users AS u ON u.gid = g.id
				WHERE u.id = '{$row->user_id}'";
				$this->_db->setQuery( $query );
				$oldl = $this->_db->loadResult();
				//echo " Old".$oldl;

				if($newl >= $oldl){
					$query = "UPDATE #__users SET gid = '{$item->gid}',
					usertype = '{$item->usertype}' WHERE id  = '{$row->user_id}'";
					$this->_db->setQuery( $query );
					$this->_db->query();

					// update the ACL
					$query = "SELECT id"
					. "\n FROM #__core_acl_aro"
					. "\n WHERE value = " . (int) $row->user_id
					;
					$this->_db->setQuery( $query );
					$aro_id = $this->_db->loadResult();


					$query = "UPDATE #__core_acl_groups_aro_map"
					. "\n SET group_id = $item->gid"
					. "\n WHERE aro_id = $aro_id"
					;

					$this->_db->setQuery( $query );
					$this->_db->query() or die( $this->_db->stderr() );
					//echo $this->_db->getQuery();exit;
				}
			}
			//print_r($row);
		}
		// Make sure the web link table is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if($item->auto_child_plans != '')
		{
			$childs = explode(',', $item->auto_child_plans);
			$row_child = & JTable::getInstance('subscr', 'Table');
			$i = 0;
			foreach ($childs as $child )
			{
				$res['sid'] = $child;
				$res['gateway'] = '.auto_content';
				$res['gateway_id'] = time() + $i;
				$res['user_id'] = $row->user_id;
				$res['pay'] = 'fail';
				$res['auto_parent'] = $sid;
				
				
				switch($plan_param->get('auto_activate_in_type'))
				{
					case "weeks";
					$offset = ($plan_param->get('auto_activate_in') * 7) * 86400;
					break;

					case "months";
					$offset = ($plan_param->get('auto_activate_in') * 30) * 86400;
					$offset = mktime(date('H'),date('i'), date('s'),(date('m') + $plan_param->get('auto_activate_in')), date('d'), date('Y')) - time();
					break;

					case "years";
					$offset = ($plan_param->get('auto_activate_in') * 365) * 86400;
					break;

					case "hours";
					$offset = $plan_param->get('auto_activate_in') * 3600;
					break;

					default:
						$offset = $plan_param->get('auto_activate_in') * 86400;
				}
					
				$res['ctime'] = $this->getMySQLDate($row->ctime, ($offset * $i) );


				if($plan_param->get('auto_child_finish'))
				{
					$res['extime'] = $row->extime;
				}
				else
				{
					$res['extime'] = $this->getMySQLDate($res['ctime'], $offset );
				}


				$this->store($res);
				$i ++;
			}
		}

		$this->published = $row->published;
		$this->user_id = $row->user_id;
		$this->subscription_id = $row->id;

		if(extension_loaded('curl') && (JCS_IDEV || JCS_AMIGOS ))
		{
			if(JCS_IDEV)
			{
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, JCS_IDEV."/sale.php?profile=72198&idev_saleamt={$row->price}&idev_ordernum={$row->id}&ip_address=".getenv('REMOTE_ADDR'));
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_exec($ch);
				curl_close($ch);
			}
			if(JCS_AMIGOS)
			{
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, JCS_AMIGOS."/index.php?option=com_amigos&task=sale&amigos_id=".JRequest::getVar('amigosid')."&amigos_ordertype=Mighty Membership&amigos_orderid={$row->id}&amigos_orderamount={$row->price}&amigos_ipaddress=".getenv('REMOTE_ADDR'));
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_exec($ch);
				curl_close($ch);
			}
		}
		else
		{
			if(!extension_loaded('curl'))JError::raiseNotice(100, JText::_('PHP extension CURL not loaded. Fail iDev integration.'));
		}
		
		
		
		return true;
	}

	function getMySQLDate($start, $offset, $type = 'SECOND')
	{
		$db = & Jfactory::getDBO();
		$sql = "SELECT '{$start}' + INTERVAL {$offset} {$type}";
		$db->setQuery($sql); 		//echo $db->_sql;
		return $db->loadResult();
	}

	function getTotalPlans()
	{
		if (empty($this->_total))
		{
			$user = JFactory::getUser();
			$access = (int) $user->get('aid', 0);
			$sql = "SELECT COUNT(*)  FROM #__jcs_plans AS p
			LEFT JOIN #__categories AS c ON c.id = p.catid
			WHERE 1 AND p.published = 1
			AND p.invisible = 0 AND c.access <= {$access}
			ORDER BY c.ordering ASC, p.ordering ASC";

			/*	$sql = "SELECT COUNT(*)  FROM #__jcs_plans AS p
			 LEFT JOIN #__categories AS c ON c.id = p.catid
			 WHERE 1 AND p.published = 1
			 AND p.invisible = 0
			 ORDER BY c.ordering ASC, p.ordering ASC";*/
			$this->_db->setQuery($sql);
			$this->_total = $this->_db->loadResult();
		}
		return $this->_total;
	}

	function calculatePrice($id, $cross, $price, $params)
	{
		$params = new JParameter($params);
		$method = $params->get('calculate_method');
		$plansAct = $this->getUserActivePlans();
		$res = array_intersect(explode(",", $cross), $plansAct);
		$priceDiff = $this->getPlanPrice(implode(",", $res));
		$subscruct = array();
		$required = $params->get('required');
		if(count($priceDiff)>0)
		{
			foreach($priceDiff as $val)
			$subscruct[] = $val->price;
		}
		if(count($subscruct)>0) rsort($subscruct);


		if($method == 'and')
		{
			if (count($res)>0)
			{
				/*if($required == 1 || ($required == 2 && count($res)==count(explode(",", $cross))))
				 {*/
				$sub = 0;
				foreach($subscruct as $val)
				$sub += $val;
				$price = (($price - $sub) > 0) ? round(($price - $sub), 2) : "0.00";
				//}
			}
		}
		else if($method == 'or')
		{
			if (count($res)>0)
			{
				//if($required == 1 || ($required == 2 && count($res)==count(explode(",", $cross))))
				$price = (($price - $subscruct[0])>0) ? round(($price - $subscruct[0]), 2) : "0.00";
			}
		}
		else
		$price = $price;
		if(!strstr(floatval($price), '.')) $price = floatval($price).'.00';


		return $price;

	}

	function getAlert($id, $cross, $params)
	{
		$db =  Jfactory::getDBO();
		$params = new JParameter($params);
		$method = $params->get('calculate_method');
		$required = $params->get('required');
		$plansAct = $this->getUserActivePlans();
		//$res = ($required) ? array_diff(explode(",", $cross), $plansAct) : array();
		$res = (!$required) ? array() : array_diff(explode(",", $cross), $plansAct);
		$crossNames = $this->getCrossPlans(implode(",", $res));
		$crossPlans = '';//array();
		$link = "index.php?option=com_jcs&view=jcs&layout=form&id=".implode(",", $res)."&Itemid=".JRequest::getInt('Itemid');
		if(count($crossNames)>0)
		{
			foreach($crossNames as $val){
				$crossPlans .= "<li><a href='".$link."'>".$val->name."</a></li>";
			}
		}
		$alert = '';

		if(count($res)>0)
		$alert = $crossPlans;

		if($required == 0)
		{
			if(count($res)==0)
			$alert = '';
		}
		if($required == '1')
		{
			if(count($res) < count(explode(",", $cross)))
			$alert = '';
		}
		return $alert;

	}

	function getPlansGrant($id, $plans)
	{
		settype($plans, 'array');
		$link = JRoute::_("index.php?option=com_jcs&view=jcs&layout=form&id=".implode(",", $plans), false);
		$sql = "SELECT name FROM #__jcs_plans WHERE id IN ( ".implode(",", $plans)." ) ORDER BY id";
		$this->_db->setQuery($sql);
		$names = $this->_db->loadResultArray();
		$list = '';
		foreach($names as $name)
		{
			$list .= "<li><a href='".$link."'>".$name."</a></li>";
		}
		return $list;

	}

	function grantPlans($parent)
	{
		$sid = explode('::', $parent['sid']);
		$sid = $sid[0];
		$sql = "SELECT params FROM #__jcs_plans WHERE id ='$sid'";
		$this->_db->setQuery($sql);
		$result = $this->_db->loadResult();
		$params = new JParameter( $result );
		$plans = $params->get('plans_grant');
		if($plans != '')
		{
			settype($plans, 'array');
			foreach($plans as $k=>$plan)
			{
				$res = array('gateway' => '.granted', 'gateway_id' => $parent['gateway_id'], 'user_id' => $parent['user_id'], 'price' => 0, 'pay' => $parent['pay'] );
				$res['sid'] = $plan;
				$this->store($res);
			}
		}
		return true;
	}


	function registerActivity($clientId, $text, $user_id,  $icon = '', $client = 'user', $ctime = null, $component = null, $params = '', $type="" )
	{
		$db = &JFactory::getDBO();
		$clientId = intval($clientId);
		$user_id = intval($user_id);
		if ($clientId < 1)
		{
			return false;
		}
		$text 	   = $db->getEscaped($text);
		$ctime     = ($ctime == null ? " NOW() " : "'{$ctime}'");
		$component = ($component == null ? '' : $component);
		$params    = $db->getEscaped($params);

		$sql = " INSERT INTO #__community_activity (`text`, `icon`, `client_id`, `client`, `component`, `ctime`, `params`, `user_id`, `type` ) "
		." VALUES('{$text}', '{$icon}', {$clientId}, '{$client}', '{$component}', {$ctime}, '$params', {$user_id}, '' )";
		$db->setQuery($sql);
		return $db->query();

	}

	function getCouponsNumber()
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT COUNT(*) FROM #__jcs_coupons WHERE published = '1'";
		$db->setQuery($sql);
		return $db->loadResult();
	}

	function getCrossPeriod($sid, $plans, $uid)
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT extime FROM #__jcs_user_subscr WHERE subscription_id IN ({$plans}) AND user_id = '$uid'
		AND published = '1' AND extime > NOW()
		ORDER BY extime DESC LIMIT 1";
		$db->setQuery($sql);
		if($res = $db->loadResult())
		return $res;
		else
		return false;
	}

	function deactivatePlans($sid, $res)
	{
		$db = &JFactory::getDBO();
		$user = JFactory::getUser();
		$sql = "SELECT params FROM #__jcs_plans WHERE id = '$sid'";
		$db->setQuery($sql);
		$params = $db->loadResult();
		$params = new JParameter($params);
		$plans = $params->get('plans_deactivate');
		if(is_array($plans)) $plans = implode(', ', $plans);
		if($plans == '') return;
		$sql = "UPDATE #__jcs_user_subscr SET published = '0' WHERE subscription_id IN ({$plans}) AND user_id = '".$res['user_id']."' AND ctime <= NOW()";
		$db->setQuery($sql);
		$db->query();

	}
	function getSubscriptionCouponInfo($sid)
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT ch.price, ch.discount, ch.discount_type, cc.value, cc.id
		FROM #__jcs_coupons_history ch
		LEFT JOIN #__jcs_coupons cc ON cc.id = ch.coupon_id
		WHERE ch.subscription_id = '$sid'";
		$db->setQuery($sql);
		return $db->loadObject();
	}
	
	function getUserSubscriptionPlans($user_id)
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT DISTINCT(p.id) 
		FROM #__jcs_user_subscr s 
		JOIN #__jcs_plans p ON p.id = s.subscription_id
		WHERE s.user_id = '$user_id'
		AND s.ctime < NOW() AND s.extime > NOW() AND s.published = '1' AND p.published = '1'";
		$db->setQuery($sql);
		return $db->loadResultArray();		
	}
	
	function getActiveSubscriptions($plan)
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT COUNT(*) 
		FROM #__jcs_user_subscr
		WHERE subscription_id = '$plan'
		AND ctime < NOW() AND extime > NOW() AND published = '1'";
		$db->setQuery($sql);
		return $db->loadResult();	
	}

}
?>